#include <unistd.h>
#include <stdio.h>
#include <limits.h>
#include "linksinfo.h"
#include "limits.h"
#include "areafix.h"
#include "readconf.h"
#include "commands.h"
#include "log.h"
#include "answer.h"
#include "sendmail.h"

main (int argc, char *argv[])
{
	
 int opt;
 char configfile[PATH_MAX];

 char passwd[MAXPASSLEN];

 link_info link0;

 strcpy( configfile,CONFIGFILE);

 while (( opt = getopt (argc,argv,"I:h") ) != EOF )
  {
   switch ( opt )
    {
    case 'I': strcpy( configfile,optarg );
     break;
    default : printhelp();
     exit(0);
    }
   
  }	

 
 ReadConfig(configfile);

 log(0,"Areafix started");

 log(1,"configfile %s",configfile);

 // 1msg - 1 file
 
 if ( ReadMsgs(&link0,passwd) )   //   <From>  .
  {
   printf ("Error while read msg!,exiting");
   exit (1);
  }

 strlwr( passwd );

 log(1,"Read message from %s@%s",link0.name,link0.domain_addr);
 
 if ( FindLink(&link0) ) // <From> 
  {
   log(4,"Areafix: got link info: ");

   log(4,"link0.ftn_addr %s",link0.ftn_addr);
   log(4,"link0.zone %s",link0.zone);
   log(4,"link0.net %s",link0.net);
   log(4,"link0.node %s",link0.node);
   log(4,"link0.point %s",link0.point);
   log(4,"link0.domain %s",link0.domain);
   log(4,"link0.domain_addr %s",link0.domain_addr);
   log(4,"link0.upasswd %s",link0.upasswd);
   log(4,"link0.apasswd %s",link0.apasswd);
   log(4,"link0.level %c",link0.level[0]);
   log(4,"link0.uareafix %s",link0.uareafix);
   log(4,"link0.forwardfile %s",link0.forwardfile);
 

   if ( ! strcmp(link0.apasswd,passwd) ) //   
    {
     log(0,"Process requests from %s",link0.ftn_addr);
     DoCommands(&link0); //.
    }
   else
    {
     log(0,"%s has incorrect password: his %s, our %s ",link0.ftn_addr,passwd,link0.apasswd);

     OpenMail(&link0.name,&link0,INCORRECTPASSWORD);
     AddMail(&link0,
             "you have incorrect password, or not found in link0s database");
     CloseMail(&link0);
    }
     
  }
 else
  log(0,"Cannot find %s in linksfile %s",link0.domain_addr,conf.LinksFile);
                  

 SendMails();
 exit (0);

}


printhelp()
{
 printf("Areafix v%s,compiled %s\n",VER,DATE);
 printf("Usage:\n \t -h this help;\n \t -I <path to config> override config file\n");
}

