#include <stdio.h>
#include <ctype.h>
#include <locale.h>
#include <stdarg.h>
#include "limits.h"
#include "linksinfo.h"
#include "lib.h"

/*     .		*
 * (   !)			*
 * TODO -    ! ;(	*/
strlwr(char *c)
{
	setlocale(LC_CTYPE,"");
	while( *c )
	{
		*c = tolower( *c );
		++c;
	}
}

strupr(char *c)
{
	setlocale(LC_CTYPE,"");
	while( *c )
	{
		*c = toupper( *c );
		++c;
	}
}

/*	    (  0-9)	*
 *	0 - , -1 - 				*/
int ifprint(int c)
{
	// 0-9
	if( c >= 48 && c <= 57 )
		return( -1 );
	// A-Z
	if( c >= 65 && c <= 90 )
		return( -1 );
	// a-z
	if( c >= 97 && c <= 122 )
		return( -1 );
	// '-'  '.'
	if( c == 45 || c == 46 )
		return( -1 );
	return( 0 );
}

copy(char *oldfile, char *newfile)
{
	FILE *f, *ff;
	char str[CHAR_MAX];

	//   -  
	if( ( f = fopen( oldfile, "r" ) ) == NULL )
		return( -1 );

	//   -  
	//   - ,    - .
	if( ( ff = fopen( newfile, "w" ) ) == NULL )
	{
		fclose( f );
		//  , ..    .
		remove( newfile );
		return( -1 );
	}

	//     
	while( fgets( str, CHAR_MAX, f ) != NULL )
     if ( fputs( str, ff ) == EOF ) //  
      {
       	//   
       fclose( f );
       fclose( ff );
       remove( newfile );
       return(-1);
       break;
      }


	//   
	fclose( f );
	fclose( ff );

	return( 0 );
}

/*	   '.'  '/'   str	*/
char *strpath(char *str)
{
	char *tmp;

	tmp = str;
	while( *str )
	{
		if( *str == '.' ) *str = '/';
		++str;
	}
	return tmp;
}



linked(char *buf, char *lzone, char *lnet, char *lnode, char *lpnt,char *level)
{

char defzone[maxels+1];
char defnet[maxels+1];
char defnode[maxels+1];

char zone[maxels+1];
char net[maxels+1];
char node[maxels+1];
char pnt[maxels+1];

char instr[MAXSTR];
 
char lv;
char *word; 


 strcpy(instr,buf);
 strcpy(defzone," ");
 strcpy(defnet," ");
 strcpy(defnode," ");
 
 word = strtok (instr," \t");

 while ( word != NULL )
  {
   //  printf("word='%s'\n",word);
   if ( (word[0]=='-') && (word[1]=='l') ) break;
   word = strtok (NULL," \t");
  }

 if (word == NULL) return(-1);
 word=word+2; //skip '-l' chars

 lv= (char) ( strtol (word,NULL,0) );
 level=lv;
 // printf("lv=%d\n",level);

 while ( word != NULL ) //check if already linked
  {
   //  printf("word=%s\n",word);
   if ( word2addr(word,zone,net,node,pnt) )
    {
     if ( (zone[0] != ' ') && ( strcmp(defzone,zone) ) )
      strcpy (defzone,zone);
     if ( (net[0]  != ' ') && ( strcmp(defnet,net)   ) )
      strcpy (defnet,net);
     if ( (node[0] != ' ') && ( strcmp(defnode,node) ) )
      strcpy(defnode,node);

     if (
         (!strcmp(defzone,lzone)) &&
         (!strcmp(defnet,lnet)) &&
         (!strcmp(defnode,lnode)) &&
         (!strcmp(pnt,lpnt))
         )
      {
       return('1');
      }

    } //if (word2addr...)

   word = strtok (NULL," \t");
  } //while 

//  printf("lzone=%s,lnet=%s,lnode=%s\n",lzone,lnet,lnode);
//  printf("defzone=%s,defnet=%s,defnode=%s\n",defzone,defnet,defnode);

 if ( strcmp(defzone,lzone) )
  {
   return('z');
  }
 else
  if ( strcmp(defnet,lnet) )
   {
    return('e');
   }
  else
   if ( strcmp(defnode,lnode) )
    {
     return('o');
    }
   else
    {
     return('p');
    }
 
}//end func



#define	SHOW(s) sprintf(buf0,"%s%s",buf1,s),strcpy(buf1,buf0) 

putln(char *str,const char *fmt, ...)
{
	char *tokp, ifmt[CHAR_MAX], *hdr = ifmt, buf[CHAR_MAX];
	char buf0[CHAR_MAX];
	char buf1[CHAR_MAX];
	
	va_list pa;

    buf[0]='\0';
    buf1[0]='\0';
    buf0[0]='\0';

    
	strcpy(ifmt,fmt);	//    
	va_start(pa,fmt);	// pa -     

	while( tokp=strchr(hdr,'%')) {	/*   "%" */
		*tokp++ = '\0';
		SHOW(hdr);		//    "%"
		if (strchr("sc%",*tokp)) { /* ,  
						    
						    */
			switch (*tokp) {
				case 's':	// %s
					strcpy(buf,va_arg(pa,char*));
					break;
				case 'c':	// %c
					buf[0] = va_arg(pa,char);
					buf[1] = '\0';
					break;
				case '%':	// %%
					strcpy(buf,"%");
					break;
				case 'd':	
				case 'i':	
					snprintf(buf,CHAR_MAX,"%i",va_arg(pa,int));
					break;
			}
			SHOW(buf);	//   
		}
		else {				/*   . -
						        */
			//fputc(*tokp,logfile);
			sprintf(buf0,"%s%c",buf1,*tokp);
			strcpy(buf1,buf0);
	}
		hdr = tokp + 1;
	}
	SHOW(hdr);		// ,   ,  
	va_end(pa);

	sprintf(buf0,"%s",buf1);
	strcpy(str,buf0);
}
