
#ifndef LINKSINFO_H
#define LINKSINFO_H

#define maxels 4  //max lenght elements in address e.g '123' in 123.45

#define ftnsize  maxels*4+3 //max length of ftn addr

/* Max passwd len */
#define	MAXPASSLEN	11

typedef struct {
 char name[50];
 char ftn_addr[ftnsize];
 char zone[maxels+1];
 char net[maxels+1];
 char node[maxels+1];
 char point[maxels+1];
 char domain[20];
 char domain_addr[CHAR_MAX];
 char level[4];
 char upasswd[MAXPASSLEN]; //uplink's areafix passwd
 char apasswd[MAXPASSLEN]; //our areafix passwd
 char uareafix[CHAR_MAX];
 char forwardfile[PATH_MAX];
 FILE *currmsg;
} link_info;

#define MAXLNKW 7

static	char LINKWORDS[MAXLNKW][20] =
{
 "startlink",      //0
 "uplink_passwd",  //1
 "uplink_areafix", //2
 "areafix_passwd", //3
 "level",	   //4
 "forward_file",   //5
 "endlink",        //6
};

char FindLink(link_info *link);
     
extern char GetLinksInfo(link_info *link,FILE *fl);
     
extern word2addr(char *word,char *wzone,char *wnet,char *wnode,char *wpnt);

extern Ftn2Domain(char *ftn_in,char *domain);

extern Domain2Ftn ( char *domain,char *ftn);

#endif LINKSINFO_H
