
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>
#include <fnmatch.h>
#include "readconf.h"
#include "lib.h"
#include "linksinfo.h"
#include "answer.h"
#include "sendmail.h"

#define  FNM_CASEFOLD	(1<<4)

char Subscribe (char *reqstr,link_info *link)
{

 FILE *af;
 FILE *tf;

 char faddr[ftnsize+1];
 char tmpname[PATH_MAX];
 char tmpstr[CHAR_MAX];
 char echo[MAXSTR+1];
 char echoname[MAXLENECHO+1];
 int pid,n=0;

 pid=getpid();

 sprintf(tmpname,"%s.afsubstmp%d",conf.AreaFile,pid);
          
 if( ( af = fopen( conf.AreaFile, "r" ) ) == NULL )
  {
   log( 0, "AreaFile \"%s\" cannot be opened!", conf.AreaFile );
   exit( 1 );
  }

 if( ( tf = fopen( tmpname, "w" ) ) == NULL )
  {
   log( 0, "tmpfile \"%s\" cannot be created!", tmpname );
   exit( 1 );
  }

 log (2, "process '%s' request.. ",reqstr);
 
 pid=0;
 OpenMail(link->name,link,SUBSCRIBERESULT);
  
 while( fgets( echo, MAXSTR, af ) != NULL ) //read areas file
  {
   strtok (echo,"\n\r");
  
   log (4, "Subscribe: got string: '%s'",echo);

   switch ( CheckEcho(echo,reqstr,faddr,echoname,link) )
    {
    case 0:
     pid++;
     sprintf(tmpstr,"%s %s",echo,faddr);
     strcpy(echo,tmpstr);
     sprintf(tmpstr,"%s %s",SUBSCRIBED,echoname);
     AddMail(link,tmpstr);
     log(2,"%s subscribed to %s",link->ftn_addr,echoname);
     n++;
     break;
    case 1:
     pid++;
     sprintf(tmpstr,"%s %s",ECHODISABLED,echoname);
     AddMail(link,tmpstr);
     log(2,"%s has not access to %s",link->ftn_addr,echoname);
     break;
    case 2:
     pid++;
     sprintf(tmpstr,"%s %s",ALREADYSUBSCRIBED,echoname);
     AddMail(link,tmpstr);
     log(2,"%s already subscribed to %s",link->ftn_addr,echoname);
     break;
    default:
    }

   if ( (fprintf(tf,"%s\n",echo)) <0 )
    {
     log(0,"unable to write file %s, aborted!",tmpname);
     exit(1);
    }
  }

 fclose(af);
 fclose(tf);

 log(3,"subscribe: %d echoes processed for %s",pid,link->ftn_addr);
 //pid == 0 - no echoes found
 
 if ( pid == 0 )
  {
   remove(tmpname);
   sprintf(tmpstr,"%s not found,try request uplink",reqstr);
   AddMail(link,tmpstr);
  }
 else
  {
   rename(tmpname,conf.AreaFile);
   sprintf(tmpstr,"%d proceed, %d echoes added",pid,n);
   AddMail(link,tmpstr);
  }

 CloseMail(link);
 return (pid);
}



CheckEcho(char *echo,char *request, char *ftnadr,char *ename,link_info *link)
{
 char tmecho[MAXSTR+1];
 char *cword;

 char defzone[maxels+1];
 char defnet[maxels+1];
 char defnode[maxels+1];

 char zone[maxels+1];
 char net[maxels+1];
 char node[maxels+1];
 char pnt[maxels+1];

 char fadr[ftnsize+1];
 char level[4];

 strcpy(tmecho,echo);

 log(5,"CheckEcho: tmecho=%s",tmecho);

 strcpy(defzone,link->zone);
 strcpy(defnet,link->net);
 strcpy(defnode,link->node);
 strcpy(pnt,link->point);

 cword=strtok(tmecho," \t"); //get EchoArea cword

 if ( strcasecmp(cword,"EchoArea") )
  {
   log(4,"CheckEcho: got strange cword: %s, skipping line",cword);
   return (255);
  }

 fadr[0]='\0';
 
 cword=strtok(NULL," \t"); //get echoname

 if ( cword == NULL ) return(250);

 if ( fnmatch (request,cword,FNM_CASEFOLD ) ) 
  {
   log(4,"CheckEcho: got echo: %s, search echo: %s skipping line",cword,request);
   return (253);
  }

 strcpy(ename,cword);

 while ( cword != NULL )
  {
   //   printf("word=%s\n",cword);
   
   if ( (strlen(cword) >= 3 ) && (cword[0]=='-') && (cword[1]=='$') && (cword[2]=='l') )
    {
     strncpy(level,cword+3,3);

     if (link->level[0] <= level[0] )
      return (1);
    }

   if ( (isdigit(cword[0])) || (cword[0]=='.'))
    {
     word2addr(cword,zone,net,node,pnt);

     if ( zone[0]=='z')
      strcpy(zone,defzone);
     else
      strcpy(defzone,zone);

     if (net[0]=='n')
      strcpy(net,defnet);
     else
      strcpy(defnet,net);

     if (node[0]=='f')
      strcpy(node,defnode);
     else
      strcpy(defnode,node);

     sprintf(fadr,"%s:%s/%s.%s",defzone,defnet,defnode,pnt);

     if (! strcmp(fadr,link->ftn_addr) )
      return(2);
    }
   
   cword=strtok(NULL," \t");
  }

 if ( fadr[0]=='\0' )
  {
   log(4,"CheckEcho: Echo %s is emty - has not links, skipping",ename);
   return(250);
  }

 fadr[0]='\0';
 
 if ( strcmp(link->zone,defzone) )
  {
   strcpy(ftnadr,link->ftn_addr);
   return(0);
  }

  if ( strcmp(link->net,defnet) )
   {
    strcpy(ftnadr,((link->ftn_addr)+strlen(link->zone)+1));
    return(0);
   }

  if ( strcmp(link->node,defnode) )
   {
    strcpy(ftnadr,
           (link->ftn_addr+strlen(link->zone)+1+strlen(link->net)+1));
    return(0);
   }

   
 sprintf(ftnadr,".%s",link->point);
 return(0);
}
