/* _compres.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * included from sqwarc[x].c	        sqwarc[x].c
 *
 * Read_Compress_Cfg,
 * From_Compress_Cfg.
 *
 */
#ifndef _COMPRES_C
#define _COMPRES_C

/*
 * Uses predefines:                   ᯮ ⠭ 樨:
 *
 * define MAXLINE 4096 Buffer len     ᨬ ࠧ  ப
 * define MAXPATH 64	 OS-aware     -ᨬ ᨬ쭠  
 * define BACKSLASH '\\' OS-aware     -ᨬ ࠧ⥫ ⥩
 *		   path delimiter
 * define ARCMAX 20  max archives     ᨬ쭮 ᫮ 娢஢
 *
 * Uses externals:                    ᯮ 譨 ६:
 *
 * char rt[], rb[]; - "rt" and "rb"
 *		     used by fopen.
 * char *your_os - prefix of OS.      䨪 樮 ⥬.
 */
#ifndef MAXLINE
#define MAXLINE 4096
#endif
#ifndef MAXPATH
#define MAXPATH 64
#endif
#ifndef BACKSLASH
#ifdef UNIX
#define BACKSLASH '/'
#else
#define BACKSLASH '\\'
#endif /* UNIX */
#endif /* BACKSLASH */
#ifndef ARCMAX
#define ARCMAX 20			/* 㦭  - ⠢ ;)*/
#endif

static char const tabspace[] = " \t";                   /*  strtok       */
static unsigned int  Num_Arcs;		/* ᪮쪮 稫 娢஢   */
static		long Offset[ARCMAX];	/* 饭  Ident		    */
static unsigned long Length[ARCMAX];	/*  ᫥⥫쭮 ⮢  */
static unsigned char *Ident[ARCMAX];	/*  ᫥⥫쭮 ⮢   */
static unsigned char *Add[ARCMAX];	/* ப  ᪠ 娢    */
static unsigned char *Name[ARCMAX];	/*  娢 (Pack)   */

/* ============ 뢠 ॢ ப    ================== */
void ClearEOL(char *s0)
{while (*s0) if ((*s0 == '\r') || (*s0 == '\n')) *s0 = '\0'; else s0++;}
/* ============ ઠ  ப   c  ᨬ  ======= */
void	strcpy2(char *s0, char *s1, char c, char *s2)
{
while (*s1) *s0++ = *s1++;
if (c) *s0++ = c; else;
while (*s2) *s0++ = *s2++;
*s0++ = '\0';
} /* void strcpy2(char *s0, char *s1, char *s2) */

/* ============================================================================
 * Reads compress.cfg and fills ta-   ⠥ compress.cfg,  ⠡窨.
 * bles. Addline  determines,  what   Addline ,  ப (Add, View,
 * lines (Add,  Extract,  or  View)   Extract) ᯮ  䨣.  -
 * are used from comress.cfg now.     ,  ⠡窨   ⮫쪮  
 * Note, that tables are built only    ⢨ (sqwarc'y 㦥 Add, 
 * for one action (sqwarc uses Add,   sqwarcx - Extract).
 * sqwarcx - Extract lines).
 *
 * Returns:
 * 1 - success.
 * 0 - unsuccess.
 * ------------------------------------------------------------------------- */

int Read_Compress_Cfg(char *AddLine, char *arcpath, char *cfg)
{
FILE *filein;
unsigned char tmp[MAXLINE+2];	/* ஬筠 ப 	    */
int i,j;
char *s0,*s1;

if ((filein = fopen(cfg,rt)) == NULL) return 0; else;
/* ======================= Compress.cfg analysing ======================== */
i = 0;					/*  ⥪饣 娢	   */
j = 0;					/*   	   */
while ((i < ARCMAX) && (fgets(tmp,MAXLINE,filein)))
	{
	ClearEOL(tmp);
	s0 = strtok(tmp, tabspace);
	if (s0 == NULL) continue; else;
	if (!stricmp(s0, "Archiver"))   /* 砫 娢 */
		{
		j = 1;
		Length[i] = 0;		/* ਧ  ।     */
		Offset[i] = 0;
		Add[i] = NULL;
		s0 = strtok(NULL, " \t;\r\n");
		if (s0 == NULL) { j = 0; continue; } else;
		Name[i] = malloc(strlen(s0));
		if (!Name[i])
			{
Err_Mem_Cfg:
			fclose(filein);
			return 0;
			}
		else strcpy(Name[i], s0);
		continue;
		} /* "Archiver" */
	else;
	if (j && !stricmp(s0, "End"))
		{				/* 砭 娢      */
		j = 0;
		i++;
		continue;
		} /* "End" */
	else;
	if (j)	{
		if (!stricmp(s0, your_os))		/* ᮮ⢥   */
		   s1 = strtok(NULL, tabspace); 	/*  ப ய */
		else s1 = s0;
		if (s1 == NULL) continue; else;
		if (!stricmp(s1, AddLine))		/* ப add	     */
		   {
		   s0 = s1 + strlen(s1) + 1;
		   while ((*s0 == ' ') || (*s0 == '\t')) s0++;
		   if (arcpath)
		      {
		      s1 = s0;
		      while (*s1 && (*s1 != BACKSLASH)) s1++;
		      if (*s1 == '\0') s1 = arcpath; else s1=empty;
		      }
		   else s1 = empty;

		   if ((Add[i] = malloc((unsigned int)(strlen(s0) + 9 +
			strlen(s1) + MAXPATH + MAXPATH))) == NULL)
			   goto Err_Mem_Cfg;
		   else;
		   strcpy2(Add[i],s1,'\0',s0);
		   continue;
		   } /* if "Add" */
		else;
		if (!stricmp(s0, "Ident"))
		   {
/* ᬥ饭 */	   if ((s0 = strtok(NULL, ",")) == NULL) continue; else;
		   Offset[i] = atol(s0);
/* 蠡 */	   if ((s1 = strtok(NULL, tabspace)) == NULL) continue; else;
		   Length[i] = strlen(s1) / 2;
		   if ((s0 = malloc((unsigned int)(Length[i] + 2))) == NULL)
			goto Err_Mem_Cfg;
		   else;
		   Ident[i] = s0;
/* 㥬 蠡 */	for (j = 0; j < (int)(Length[i]); j++)
			{
			*s1 = (char)toupper((int)(*s1));
/*   */	*s0 = (char)((*s1 <= '9')?(*s1 - '0')
					    :((int)(*s1) - 'A' + 10));
			*s0 <<= 4;
			s1++;
			*s1 = (char)toupper((int)(*s1));
/*   */	*s0 += ((*s1 <= '9')?(*s1 - '0')
					   :(*s1 - 'A' + 10));
			s1++;
			s0++;
			} /* for j < Length[i] */
		   j = 1;
		   continue;
		   } /* if "Ident" */
		else;
		} /* if j */
	else;
	} /* while(fgets) */
Num_Arcs = i;
if (ferror(filein)) i = 0; else;
if (fclose(filein)) i = 0; else;
if ((i == 0) || (i > ARCMAX)) return 0; else return 1;
} /* Read_Compress_Cfg */

/* =====================  娢  ⭮ બ? ======== */
char **From_Compress_Cfg(char *pathname_arc, char *arctype, char *pathname_pkt)
{
struct stat f;
FILE *filein;
static char *args[MAXARGS];
int matched, i,k;
char *s0;
static unsigned char tmp[MAXLINE+2];	/* 			    */

/* =============================== Is here arcmail? ======================== */
if ((!stat(pathname_arc,&f)) && (f.st_size))
   filein = fopen(pathname_arc,rb);
else filein = NULL;
/* =============================== Reading arcmail ========================= */
matched = 0;
for (i = Num_Arcs - 1; i >= 0; i--)	/* 横 ॡ 娢஢ */
					/*   બ      */
	{
	if (Length[i] == 0) continue; else; /*  ।  */
/* ᫨ બ  -  ࠢ  ப arctype */
	if (filein == NULL)
	   if (!stricmp(Name[i], arctype)) break; /* ᮢ - 室 */
	   else continue;		/*  ᮢ - த ᪠ */
	else;
/* ᫨  બ - 饬 ᨣ  䠩 */
	if (Offset[i] < 0)		/*     */
	   fseek(filein,Offset[i],SEEK_END);
	else				/*   砫 䠩 */
	   fseek(filein,Offset[i],SEEK_SET);
	k = fread((void *)tmp,1,(size_t)Length[i],filein);
	if (k != (int)(Length[i]))
		{			/* ᫨ ⠫    */
		continue;		/* ஡ 㣮 .   */
		}
	else;
	matched = 1;
	for (k = 0; k < (int)(Length[i]); k++)	/* 横 ࠢ ᫥- */
						/* ⥫쭮⥩  Ident  䠩*/
	    if (tmp[k] != *(Ident[i] + k))
		{
		matched = 0;		/*  ᮢ		     */
		break;
		}
	    else;

	if (matched) break; else;	/* ᮢ		     */
	} /* for i = Num_Arcs; i-- */
if (filein) fclose(filein); else;		/*  બ	    */
if (i < 0) return NULL; else;			/*  稫 娢   */

strcpy(tmp,Add[i]);				/* ஢   tmp*/
args[0] = strtok(tmp,tabspace);
i = 0;
while(((args[++i] = strtok(NULL, tabspace)) != NULL) && (i < MAXARGS))
	{
	s0 = args[i];
	if (*s0 == '%')
	   {
	   s0++;
	   if (*s0 == 'a') args[i] = pathname_arc; /* %a  */
	   else
	      if (*s0 == 'f')           /* %f  argv[1].pkt */
		 args[i] = pathname_pkt;
	      else;
	   } /* if *s0 == '%' */
	else;
	} /* while ((args[++i] = strtok) != NULL) */
/*   args 㦭    */
#if DEBUG
/**/puts("\nargs:"); for (k = 0; k <= i; k++) printf("%s ", args[k]);
/**/fputs("End of From_Compress_Cfg. Press Enter to continue>", stderr); getchar();
#endif
if (args[i] == NULL) return args; else return NULL;
} /* From_Compress_Cfg() */

#endif /* _COMPRES_C */

