/* sqw-adr.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * FTN-addresse parsing subroutines   ணࠬ ࠧ FTN-   ⥪-
 * from text lines.                   ⮢ ப.
 */

#include "./sqw-inc.h"

int	Get_Domain(char *);
int	Sqw_adr(char **);
int	cr_padr(char **, unsigned int *);
int	next_addr(char *s0, unsigned short int *net, unsigned short int *node);

/* ============================================================================
 * Receives pointer to domain begi-   砥 㪠⥫  ப  
 * nning (may be with @ before it).     @ ।. ᫨   -
 * If  Domains  are  used  (keyword    (  ࠧ  sqwish.cfg -
 * Domain encouneterd in sqwish.cfg   ⨫ 祢 ᫮ Domain), ६
 * at least one  time,  and  Domain   Domain ।⠢ ࠧ ⠡窨  Dmn,
 * global variable represents  num-     ப Domain.
 * ber of domains in Dmn table.
 *
 * Returns domain number in table,    頥    ⠡窥,  ᫨
 * if domain is found;                 ;
 * Returns 0, if not found.           頥 0, ᫨  .
 * ========================================================================= */

int	Get_Domain(char *t)
{ int i = 0;			/* 稪  頥 祭 0  */
  char *t0, c;			/*    ⠡		 */

if (*t == '@') t++; else;

/*
Debug(Format_s, t);
*/

/*
 * FTS-0049 - domain must be  case-    FSC-0049  ࠢ  ॣ-
 * insensitive, 8 first symbols are   ᨬ,  8 ᨬ, 窠  
 * unique, . or @ ends domain  com-   @ 稢 ࠢ .
 * parison.
 */

if (Cfg_Domain)
	{
	i = 8;
	t0 = t;
	while ((*t0 != '.') && (*t0 != '@'))
		if (--i < 0) break; else t0++;
	c = *t0;
	*t0 = '\0';
/**
	Debug(Format_s, t);
*/
	i = Cfg_Domain;
	while (i && strcmp(Dmn[i].name, t)) i--; /* 0   . */
	Lin->domain = i;
	i = (i != 0);
	*t0 = c;
	} /* if (Cfg_Domain) */
else Lin->domain = 0;
return i;
} /* Get_Domain() */

/*-------------------------------   -----------------------------*/
#define skipnumb(A) while ((*A <= '9')&&(*A >= '0')) (A)++
/*------------------------------- ய ஡ --------------------------*/
#define skipspace(A) while ((*A == ' ')||(*A == '\t')) (A)++
/*-------------------------------  ஡   ப ---------*/
#define skipword(A) while((*A !=' ')&&(*A !='\t')&&(*A !='\0')&&(*A !='\r')&&(*A !='\n')&&(*A !=';')) (A)++
/*-----------------------------------------------------------------------------
   Full   only  address  analysis!         ⮫쪮  !!!
   Returns !0 on success, 0 on illegal    頥 !0  ᯥ, 0 - ᮮ.
   Changes *s                              㪠⥫ *s

   Used in Sqw_cr.c, Sqw_pr.c

   addresse form is: Zone:Net/Node[.Point][@domain]

-----------------------------------------------------------------------------*/
int Sqw_adr (char **s)
{
char	*t;			/* ஬ 㪠⥫  ப	     */
char	c;			/* । ᨬ ப, ࠭	     */
int	i = 1;			/* 頥 祭  稪    */

Lin->Zone  = 0;			/* 樠  ⥪饣        */
Lin->Net   = 0;
Lin->Node  = 0;
Lin->Point = 0;
Lin->domain = 0;

skipspace(*s);			/* ய ஡ । ᮬ	     */
t = *s;				/* t 㪠뢠  砫  	     */
skipnumb(*s);			/* *s 㪠뢠    	     */
if (**s != ':') return 0;	/* ᫨   -  ७        */
**s = '\0';			/*  稥 		     */
Lin->Zone = atoi (t);		/*   			     */
(*s)++;				/*   ᫥騩 ᨬ	     */

t = *s; skipnumb(*s);
if (**s != '/') return 0; else;
**s = '\0'; Lin->Net = atoi (t);
(*s)++;

t = *s; skipnumb(*s);
c=**s;
**s = '\0';
Lin->Node = atoi (t);

if (c != '.') Lin->Point = 0;
else
   {
   **s = c;
   (*s)++;
   t = *s;
   skipnumb(*s);
   c = **s;
   **s = '\0';
   Lin->Point = atoi (t);
   }
if (c == '@')
   {
   **s = c;
   (*s)++;
   t = *s;
   skipword(*s);
   c = **s;
   **s = '\0';
   i = (Get_Domain(t) != 0);
   }     
**s = c;
return i;
} /* Sqw_adr()*/
/*****************************************************************************
Partial address analysis                               筮 

Returns (see sqw-def.h, enum here_addr):
-1  end of line                       ப
0   no addresse here                  
ALDN                   [[Zone:]Net/][Node][.Point][@Domain]
ALAD               [-]+[[Zone:]Net/][Node][.Point][@Domain]
3                    -p[[Zone:]Net/][Node][.Point][@Domain]
ALUP                 -x[[Zone:]Net/][Node][.Point][@Domain]
5                    -u[[Zone:]Net/][Node][.Point][@Domain]
(--- not realized yet -----
6                    -0
7                    -$
8		     -$m
9		     -$d
10		     -$s
--------------------------)
Found space or tabulation as first    ᫨ ᭠砫  ஡  ⠡樨,
symbol - skips all space/tabs to:       ய᪠ :
      '0'-'9', '.', '/' - address.          , 窠  / - .
Changes ptr to symbol after it.        㪠⥫  ⮣ .
Analyse address to Lin                㥬    Lin
----------------------------------------------------------------------------*/
int cr_padr (char **s, unsigned int *here_number)
{
register char *t;                 /* ன 㪠⥫  ப              */
register char c;                  /* । ᨬ  ப              */

int here_addr = HERE_NOADDR;

*here_number = 0;
Lin->Point = 0;			  /*    㬮砭    */
skipspace(*s);
switch (**s)
     {
     case ';': case '\0': case '\r': case '\n': return HERE_EOL;
     case '-':
	(*s)++;
	switch (toupper(**s))
        	{
                case ';': case '\0': case '\r': case '\n': return HERE_EOL;
        	case 'X': here_addr = HERE_X; break;
        	case 'P': here_addr = HERE_P; break;
        	case '+': here_addr = HERE_LINK; break;
#if 0
        	case '$': here_addr = HERE_DOLLAR; break;
        	case '0': here_addr = HERE_ZERO; skipword(*s); return HERE_ZERO;
#endif
                case '\t':
                case ' ': return HERE_NOADDR;
/*###024*/	case 'U': here_addr = HERE_MINUSU; break; /*###045*/
        	default:  skipword(*s); return HERE_NOADDR;
        	}
        (*s)++;
	break;
     case '+': here_addr = HERE_LINK; (*s)++; break;
     case '0': case '1': case '2': case '3': case '4': case '5':
     case '6': case '7': case '8': case '9': case '/': case '.':
     case '@':
    	here_addr = HERE_LINK; break;
     default: skipword(*s); return HERE_NOADDR;
     } /* switch toupper **s */
#if 0
if (here_addr == HERE_DOLLAR)
   {
   (*s)++;
   switch(toupper(*(*s)++))
   	{
   	case 'M': here_addr = HERE_DOLLAR_M; break;
   	case 'D': here_addr = HERE_DOLLAR_D; break;
   	case 'S': here_addr = HERE_DOLLAR_S; break;
   	default: skipword(*s); return HERE_DOLLAR;
   	}
   t = *s;
   skipnumb(t);
   c = *t;
   *t = '\0';
   *here_number = atoi(*s);
   *t = c;
   *s = t;
   return here_addr;
   } /* if (here_addr == HERE_DOLLAR) */
else;
#endif

t = *s;
skipnumb(t);			/* t -   ᨬ ᫥ ᫠       */
c = *t;				/*   ᨬ                  */
*t = '\0';			/*   㫨                   */
switch (c)			/*  ⥯ - ஢   ᨬ */
       {
       default:			/* ᫨   :/.@ -   -   */
            if (*s != t) Lin->Node = atoi (*s); else;
            *t = c;
            *s = t;
            return here_addr;
       case '@':		/* Node@Domain				  */
            if (*s != t) Lin->Node = atoi (*s); else;
            *t = c;
            *s = t;
            skipword(t);
            c = *t;
            *t = '\0';
	    Get_Domain(*s);
	    *t = c;
            *s = t;
            return here_addr;
                                  /* ᫨ / -                */
       case '/':       /******** Net/Node[.Point][@Domain] ******************/
            {
            char *tmp = t;
            t = *s;
            *s = tmp;
            }
            goto Node_Entry;
                                  /* ᫨ : - 稭           */
       case ':':                  /***** Zone:Net[/Node[.Point]][@Domain] ***/
            if (*s != t) Lin->Zone = atoi (*s); else;
            *t++ = ':';
            *s = t;
            skipnumb(*s);
            c = **s;
            **s = '\0';
Node_Entry:
            if (c == '/')
               {    /********** [Zone:]Net/Node[.Point][@Domain] ****/
               if (*s != t) Lin->Net = atoi(t); else;
               **s = '/';
               (*s)++;
               t = *s;
               skipnumb(t);
               c = *t;
               *t = '\0';
       case '.':       /******** Node.Point[@Domain] ****************/
               if (t != *s) Lin->Node = atoi(*s); else;
               *t = c;
               if (c == '.')	/* [Zone:Net/]Node.Point[@Domain] */
                  {
                  t++;
                  *s = t;
                  skipnumb(*s);
                  c = **s;
                  **s = '\0';
                  Lin->Point = atoi (t);
                  **s = c;
                  if (c == '@')	/* [...]@Domain */
                     {
                     t = *s;
                     skipword(t);
                     c = *t;
                     *t = '\0';
                     Get_Domain(*s);
                     *t = c;
                     *s = t;
                     }
                  else;
                  return here_addr;
                  } /* if c == '.' */
               else
                  {
                  if (c == '@')
                       {
                       *s = t;
                       skipword(t);
                       c = *t;
                       *t = '\0';
                       Get_Domain(*s);
                       *t = c;
                       }
                  else;
                  *s = t;
                  return here_addr;
                  } /* else c == '.' */
               } /* if c == '/' */
            else {
                 if (*s != t) Lin->Net = atoi(t); else *s = t;
                 return here_addr; /**** Zone:Net ***********************/
                 }
       } /* switch c */
} /* int cr_padr (char **s) */

/*****************************************************************************
 * fills net/node. Returns:                㧫. :
 * 0 no addresse                      0 -   
 * 1 node only                        1 - ⮫쪮  㧫
 * 2 net/node                         2 -   /  㧫
 *---------------------------------------------------------------------------*/
int next_addr(char *s0, unsigned short int *net, unsigned short int *node)
{
unsigned short int tmp1, tmp2;
switch (sscanf (s0, net_node, &tmp1, &tmp2))
	{
	case  1: *node = tmp1; return 1;
	case  2: *net = tmp1; *node = tmp2; return 2;
	default: break;
	}
return 0;
} /* next_addr() */

