/* sqw-os.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * This is special  module  created    ⮬ 㫥 室 㭪樨, 
 * for different OS,  than  classic     ⥪  ,  -
 * DOS. Functions finfirst/findnext    ᪨  ,  樮.  
 * substitutions are placed here.     ⭮,  findfirst/findnext.
 *
 * There  are some  replacements of    ⠪ 室   
 * buggy or potentionally dangerous     ⥭樠쭮  㭪
 * functions from standard librari-    ⠭ ⥪.  :
 * es. Such as qsort,  stat,  ctime   qsort, ctime, stat  ⥪ ࡮
 * in Turbo C 2.0.		       2.0.
 *
 */

/*
 * Some buggy linkers  can't  parse       㬥  -
 * true empty moddules.  This  line   짮 ᮢ襭  㫨. 
 * is 'bugfix' for such situations.   ப  "䨪" ⠪ .
 *
static char sqw_os;
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include "./sqw-os.h"   /* OS-aware definitions */

#include "./sqw-cfg.h"
#include "./sqw-def.h"
#include "./sqw-type.h"
#include "./sqw-hdr.h"
#include "./sqw-ext.h"
#include "./sqw-lin.h"
#include "./sqw-prot.h"

static const char *const Months[12] = {
	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

/*
 * Function  analyses  text  string   㭪  ⥪⮢  ப  
 * and returns  unixtime  according   頥  ᮮ⢥饥   祭
 * to it. Returns 0L if date is in-   unixtime.     頥
 * valid.  If line represents valid   0L. ᫨ ப 楫 - ⨬ -
 * hex value - returns it.            ᫮  hex-, ८ࠧ .
 */
time_t Date_From_Line(char *line)
{
char dashsp[] = " -";
char *s0;
time_t ret = (time_t)(strtoul(line, &s0, 16));

if (*s0 || (!ret))				/* text form of date */
   {
#if defined(__TURBOC__)
   struct time t;
   struct date d;

   t.ti_hund = 0;
   t.ti_sec = 0;
   t.ti_min = 0;
   t.ti_hour = 0;
   s0 = strtok(line,dashsp);
   if (s0) d.da_day = (char)(atoi(s0)); else return 0L;
   s0 = strtok(NULL,dashsp); if (s0 == NULL) return 0L; else;
   d.da_mon = 0;
   do d.da_mon++;
      while((d.da_mon < 12) && (stricmp(Months[d.da_mon],s0)));
   if (d.da_mon == 12) return 0L; else;
   s0 = strtok(NULL,dashsp);
   if (s0) d.da_year = atoi(s0); else return 0L;
   d.da_mon++;
   ret = (time_t)dostounix(&d,&t);

#else
   struct tm t;
   t.tm_sec = 0;
   t.tm_min = 0;
   t.tm_hour = 0;
   t.tm_isdst = -1;
   s0 = strtok(line,dashsp);
   if (s0) t.tm_mday = atoi(s0); else return 0L;
   s0 = strtok(NULL,dashsp); if (s0 == NULL) return 0L; else;
   t.tm_mon = 0;
   do t.tm_mon++;
      while((t.tm_mon < 12) && (stricmp(Months[t.tm_mon],s0)));
   if (t.tm_mon == 12) return 0L; else;
   s0 = strtok(NULL,dashsp);
   if (s0) t.tm_year = atoi(s0) - 1900; else return 0L;
   ret = mktime(&t);
#endif
   if (ret == (time_t)(-1)) return 0L; else;
   }
else;
return ret;
}

#include "./_datefil.c"

#ifdef __VC60__
/*
 * This is module for Win32 version       ᨨ  SqWish  Win32,
 * built with Microsoft Visual C++,   ᮡࠥ  ⮢᪨ Visual C++
 * version 6.0 (tested).	      ᨨ 6.0 (஢﫮).
 *
 */

int findfirst(const char *pathname, struct ffblk *f, int attrib)
{

f->handle = _findfirst(pathname, &(f->fdata));

f->ff_fsize = (f->fdata).size;
f->ff_name  = (f->fdata).name;
f->ff_attrib = (f->fdata).attrib;
f->unixtime = (f->fdata).time_write;

if (f->handle != -1) return 0;
else return -1;
}

int findnext(struct ffblk *f)
{
int ret;

if (f->handle == -1)
	{
#ifdef Erl_Error
	Errexit("Bug! FindNext without FindFirst!",Erl_Error);
#else
	printf("Bug! FindNext without FindFirst!"); exit(255);
#endif
	}
else;

ret  = _findnext(f->handle, &(f->fdata));

f->ff_fsize = (f->fdata).size;
f->ff_name  = (f->fdata).name;
f->ff_attrib = (f->fdata).attrib;
f->unixtime = (f->fdata).time_write;

if (!ret) return 0; else;
_findclose(f->handle);
f->handle = -1;
return ret;
}
#endif /* __VC60__ */

#ifdef __MSC60__
/*
 * This is module for DOS16 version       ᨨ  SqWish  DOS16,
 * built with Microsoft C 6.0. C++,   ᮡࠥ  ⮢᪨ C 6.0.
 *
 */

int findfirst(const char *pathname, struct ffblk *f, int attrib)
{

f->handle = _dos_findfirst(pathname, attrib, &(f->fdata));

f->ff_fsize = (f->fdata).size;
f->ff_name  = (f->fdata).name;
f->ff_attrib = (f->fdata).attrib;

if (f->handle != -1) return 0;
else return -1;
}

int findnext(struct ffblk *f)
{
int ret;

if (f->handle == -1)
	{
#ifdef Erl_Error
	Errexit("Bug! FindNext without FindFirst!",Erl_Error);
#else
	printf("Bug! FindNext without FindFirst!"); exit(255);
#endif
	}
else;

ret  = _dos_findnext(&(f->fdata));

f->ff_fsize = (f->fdata).size;
f->ff_name  = (f->fdata).name;
f->ff_attrib = (f->fdata).attrib;

if (!ret) return 0; else;
f->handle = -1;
return ret;
}
#endif /* __MSC60__ */

#ifdef UNIX
/* This is module for UNIX  version       ᨨ  SqWish   UNIX.
 * of SqWish. There are definitions        ।   ᪨	㭪樨
 * of DOS  findfirst/findnext under   findfirst/findnext  UNIX.
 * UNIX.
 *
 * Thanks to Ivan Munitsin, 2:5020/418!
 *
 */

int findfirst(const char *pathname, struct ffblk *ffblk, int attrib)
{
char *pos;
struct stat buf;
char findpath[NAME_MAX];

   strcpy(findpath, pathname);
   if ((pos=(char *)strrchr(findpath, '/'))==NULL) {
      strcpy(ffblk->fname, findpath);
      strcpy(findpath, ".");
   }
   else {
      strcpy(ffblk->fname, pos+1);
      *pos='\0';
   }

   ffblk->dir=opendir(findpath);
   while ((ffblk->entry=readdir(ffblk->dir))!=NULL) {
      if (strcasecmp_match(ffblk->entry->d_name, ffblk->fname) == 0) {
	 ffblk->ff_name=ffblk->entry->d_name;
	 stat(ffblk->ff_name, &buf);
	 ffblk->ff_fsize=buf.st_size;
	 return 0;
      }
   }
   closedir(ffblk->dir);
   return -1;
}

int findnext(struct ffblk *ffblk)
{
struct stat buf;

   while ((ffblk->entry=readdir(ffblk->dir))!=NULL) {
      if (strcasecmp_match(ffblk->entry->d_name, ffblk->fname) == 0) {
	 ffblk->ff_name=ffblk->entry->d_name;
	 stat(ffblk->ff_name, &buf);
	 ffblk->ff_fsize=buf.st_size;
	 return 0;
      }
   }
   closedir(ffblk->dir);
   return -1;
}
#endif /* UNIX */

/********************* । ᢮ ࠧ  ********************/
#if defined(DJGPP) || defined(UNIX) || defined(__EMX__) || defined(__VC60__) || defined(__WATCOMC__)
unsigned long farcoreleft()
{
if (Cfg_MaxMemoryUsage) return ((unsigned long)Cfg_MaxMemoryUsage << 10);
else return 1000000L;
}
#elif defined(__MSC60__)
unsigned long farcoreleft()
{
struct _heapinfo hi;
unsigned long ret = 0L;

if (Cfg_MaxMemoryUsage) return ((unsigned long)Cfg_MaxMemoryUsage << 10);
else;

_heapmin();

/**/ printf("\n");
hi._pentry = NULL;
while( _heapwalk( &hi ) == _HEAPOK )
     {
     if (hi._useflag != _USEDENTRY)
	{
/**/	 printf( "\t%s block at %Fp of size %u\t\n",
/**/	       hi._useflag == _USEDENTRY ? "USED" : "FREE",
/**/	       hi._pentry,
/**/	       hi._size );
/**/	printf ("ret was = %lu;", ret);
	ret += (unsigned long)(hi._size);
/**/	printf (" hi._size = %lu; ret become = %lu\n",
		(unsigned long)(hi._size), ret);
	}
	else;

     }
return (ret);
} /* farcoreleft() in __MSC60__ */
#elif (defined(__TURBOC__))
/* TC 2.0 has true farcoreleft() */
#endif

/************************** mhdate() ****************************************
 * Sets current  LOCAL date/time in   ⠭  /६  -
 * message header.		       ᮮ饭.
 */

void mhdatime(MSG_hdr *mh)
{
time_t timer;
char *timeline;

time(&timer);
timeline = ctime(&timer);
/*-------------------------------------------------------------------------
I assume format of ctime-returned      ࠧ㬥 ଠ ப,
line as:			     饭 㭪樥 ctime():
		     "Sun Jul 28 12:58:12 1999\n"
And convert it to:		      ॢ  :
		     "Sun 28 Jul 99 12:58\0"
symbol position >     01234567890123456789 <  ᨬ
-------------------------------------------------------------------------*/
sprintf (mh->DateTime,"%.3s %.2s %.3s %.2s %.5s",
	timeline, timeline + 8, timeline + 4, timeline + 22, timeline + 11);

} /* mhdatime() */

/************************** phdate() ****************************************
 * Sets current LOCAL date/time  in   ⠭  /६  -
 * packet header.		       .
 */
void phdatime(PKT_hdr *ph)
{

#if defined(__TURBOC__) || defined(UNIX) || defined(DJGPP)
time_t timer;
struct tm *tmtime;

time(&timer);
tmtime = localtime(&timer);

ph->year   = tmtime->tm_year + 1900;
ph->month  = tmtime->tm_mon;
ph->day    = tmtime->tm_mday;
ph->minute = tmtime->tm_min;
ph->hour   = tmtime->tm_hour;
ph->second = tmtime->tm_sec;

#else

/*   ।    00:00:00 01 Jan 1986 */
ph->year   = 1986;
ph->month  = 0;
ph->day    = 1;
ph->minute = 0;
ph->hour   = 0;
ph->second = 0;
#endif

/* ###059
 * If date/time is too incorrect...
 */
if (ph->month > 11) ph->month = 0; else;
if ((ph->day == 0) || (ph->day > 31)) ph->day = 1; else;
if (ph->hour > 23) ph->hour = 0; else;
if (ph->minute > 59) ph->minute = 0; else;
if (ph->second > 59) ph->second = 0; else;

/**
Debug("year of packet is %i, month is %i", ph->year, ph->month);
**/

} /* phdatime() */

/*
 *
 * qsort replacement.		       㭪樨 ஢.
 *
 */

/* ###040 --------------------------------------------------------------------
Simple replace for  standard  qsort   ⥩  筮 qsort  -
function  -  bubble  sorting,  only   쪮 ஢,  	⮫쪮
short int indexes (qWidth is assum-   ⪨ 楫 ( qWidth  ࠧ㬥
ed to be 2).			      ࠢ 2).

Created to solve problems with sta-     樨 ஡  ⠭-
ndard function - it is	recursively   ⭮, ४ᨢ ᠭ qsort, -
written and eats memory in some ca-   饩    ⪮ -
ses...				      ⢮ ...

If qsort in your library  cause  no   ᫨  襩 ⥪ ஡   ⠭-
problems - you may disable this fu-   ⭮ qsort  -   
nction by -DQSORT key in  makefile.   ᮪  箬 -DQSORT  -䠩.

---------------------------------------------------------------------------- */
#ifndef QSORT

typedef int comparF (const void *, const void *);

static	comparF    *Fcmp;
static	unsigned    qWidth;

/* Bubble version for integer only*/

/*------------------------------------------------------------------------*/
void  qsort (void *baseP, size_t nElem, size_t width, comparF *compar)

{
int i,j,c;
int *s1 = (int *)baseP;

Fcmp = compar;

	if ((qWidth = width) == 0)  return;
	Fcmp = compar;
	for (i = nElem - 1; i > 0; i--)
	    for (j = 0; j < i; j++)
		{
		if (Fcmp(s1+j, s1+j+1) > 0)
		   {
		   c = s1[j+1];
		   s1[j+1] = s1[j];
		   s1[j] = c;
		   }
		}
}
#endif

#ifdef __TURBOC__

static const char Days[12] = {
	31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
};
static const char *const Weekday[7] = {
	"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
};
/* ---------------------------------------------------------------------------
 * Fool-proof ctime() function	for   ࠪ⮩稢  㭪  
 * Turbo C 2.0 to work properly  in   ⥪ ࡮  2.0, ଠ쭮 ࠡ-
 * unixtime after 0x80000000.	        ६  0x80000000.
 *
 * Rewritten from Turbo C 2.0  Run-   ९ᠭ  䠩 ⥪ ctime.c
 * time library file ctime.c
 *
 * Standard ctime()   fills  string   ⠭⭠ ctime()  ॢ襭  unix-
 * with garbage instead of weekdays   ६ ᫠ 0x80000000  -
 * and negative numbers instead  of    ஬    ⥫묨  祭ﬨ
 * positive numbers. It is a result       ⥫  ᥫ.
 * of operation % applied to signed    १ ਬ 樨  
 * negative numbers.  I've set both   ⪠  ⥫   ᫠.
 * variables been %-ed, to unsigned    ६,  থ 樨 %,
 * and eliminate this problem.	        묨,  祬    ࠭
 *				      ஡.
 *
 * ------------------------------------------------------------------------- */

/* Definition  of  Daylight  Saving   ।  㭪樨 㦥 Daylight
 * function			      Saving.
 */
int  pascal __isDST	  (unsigned hour,  unsigned yday,
			   unsigned month, unsigned year);

/*------------------------------------------------------------------------
 *
 * function(s)
 *	  comtime   - converts long timedate to a structure
 *	  asctime   - converts date and time to ASCII
 *	  ctime     - converts date and time to a string
 *	  gmtime    - converts date and time to Greenwich Mean Time
 *	  localtime - converts date and time to a structure
 *-----------------------------------------------------------------------*/

static	struct	tm tm;

/*---------------------------------------------------------------------*

Name		comtime

Usage		static struct tm *comtime(long time, int dst);

Prototype in	local to this module

Description	fills the time structure tm by translating the long
		time.

Return value	the broken down time structure. This structure is
		a static which is overwritten with each call.

*---------------------------------------------------------------------*/
static	struct	tm *comtime(long SignedTime, int dst)
{

/* unsigned long time - is the main
 * change from standard ctime.c
 */
unsigned long time = (unsigned long)SignedTime;
unsigned int	cumdays;	/* added unsigned */

	int	hpery;
	long	i;		/* number of tetrayears */
#if (sizeof(time_t) != 4)

	long	j,		/* number of hundreds	*/
		k;		/* number of tetrahundreds */
#endif

	#pragma warn -sig

	tm.tm_sec = time % 60;
	time /= 60;			/* Time in minutes */
	tm.tm_min = time % 60;
	time /= 60;			/* Time in hours */

	tm.tm_year = 70;

#if (sizeof(time_t) == 4)
#else
	k = time / ((1461L * 24L * 25L * 4) - 3);
	j = (k * ((1461L * 24L * 25L * 4) - 3));

#endif	/* else sizeof(time_t) == 4 */

	i = time / (1461L * 24L);	/* i = time in tetrayears */
	tm.tm_year += (i << 2); 	/* tetrayears * 4 */
	cumdays = 1461 * i;		/* total days in tetrayears */
	time %= 1461L * 24L;		/* left from last tetrayear */
	for	(;;){
		hpery = 365 * 24;	/* hours per one year */
		if (
		    ((tm.tm_year & 3) == 0) &&
		    (((((unsigned)tm.tm_year) % 100) != 0) ||
		     ((((unsigned)(1900 + tm.tm_year)) % 400) == 0)
		    )
		   )
			hpery += 24;
		if (time < hpery)	/* ᫨ ⠫  ᮢ, */
			break;		/* 祬   -   横 */
		cumdays += hpery / 24;	/* ਡ    total */
		tm.tm_year++;		/* ਡ 1   */
		time -= hpery;		/*   ᮢ  */
	}

	if	(dst && daylight &&
		 __isDST( time % 24, time / 24, 0, tm.tm_year-70 )){
		time++;
		tm.tm_isdst = 1;
	}
	else

		tm.tm_isdst = 0;
	tm.tm_hour = time % 24;
	time /= 24;				/* Time in days */
	tm.tm_yday = (int)time;
	cumdays += (int)time + 4;
	tm.tm_wday = cumdays % 7;

	time++;
	if ((tm.tm_year & 3) == 0){
		if (time > 60)
			time--;
		else if (time == 60){
			tm.tm_mon = 1;
			tm.tm_mday = 29;
			return(&tm);
		}
	}
	for	(tm.tm_mon = 0; Days[tm.tm_mon] < time; tm.tm_mon++)
		time -= Days[tm.tm_mon];
	tm.tm_mday = time;

	#pragma warn .sig

	return(&tm);

} /* comtime()*/

/*------------------------------------------------------------------------*

Name		asctime   - converts date and time to ASCII
		ctime	  - converts date and time to a string
		gmtime	  - converts date and time to Greenwich Mean Time
		localtime - converts date and time to a structure

Usage		#include <time.h>
		char *asctime(struct tm *tm);
		char *ctime(long *clock);
		struct tm *gmtime(long *clock);
		struct tm *localtime(long *clock);

Prototype in	time.h

Description	asctime  converts  a  time  stored  as	a  structure  to  a
		26-character string in the following form:

			Mon Nov 21 11:31:54 1983\n\0

		All the fields have a constant width.

		ctime converts a time pointed to by clock (such as returned
		by the function time) to  a 26-character string of the form
		described above.

		localtime   and  gmtime   return  pointers   to  structures
		containing the broken-down time. localtime corrects for the
		time  zone  and  possible  daylight  savings  time;  gmtime
		converts directly to GMT.

		The global  long variable timezone contains  the difference
		in  seconds between  GMT and  local standard  time (in EST,
		timezone  is  5*60*60).  The  global  variable	daylight is
		non-zero  if  and  only  if  the  standard  U.S.A. Daylight
		Savings Time conversion should be applied.

Return value	asctime and ctime return a  pointer to the character string
		containing the date and time. This string is a static which
		is overwritten with each call.

		gmtime and localtime return the broken down time structure.
		This structure is  a static which is overwritten  with each
		call.

*---------------------------------------------------------------------------*/
struct	tm	*gmtime(const long *clock)
{
	return(comtime(*clock, 0));
}

struct	tm	*localtime(const long *clock)
{
	long	x;

	tzset();		/* get timezone info */
	x = *clock - timezone;
	return(comtime(x, 1));
}

/* Fool-proof asctime() 	      ࠪ⮩稢 㭪 asctime()
 */

char	*asctime(const struct tm *tm)
{
	static	char	a[26];

/* Corrected format line to set ma-    ଠ⭮ ப ⠭ ᨬ-
 * ximum lengths of fields to mini-         ࠭ ࠧ-
 * mize crash  results	of  idiotic   ⥫ १⮢ - ᪨ 室-
 * input parameters.		          tm.
 *
 * All parameters  are	normalized,     ࠬ  ଠ,  ᪮쪮
 * as possible, to valid range by %   ,  ⨬  -
 * and & operations.		      ﬨ %  &.
 *
 */
	sprintf(a, "%.3s %.3s %02.2d %02.2d:%02.2d:%02.2d %4.4d\n",
	Weekday[((unsigned)tm->tm_wday) % 7],
	Months[((unsigned)tm->tm_mon) % 12],
	((unsigned)tm->tm_mday & 31),
	((unsigned)tm->tm_hour) % 24,
	((unsigned)tm->tm_min) % 60,
	((unsigned)tm->tm_sec) % 60,
	tm->tm_year + 1900);
	return(a);
} /* asctime() */

char	*ctime(const long *clock)
{
	return(asctime(localtime(clock)));
} /* ctime() */

#else

#endif
