/* sqw-pr.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Inbound packets reading.	      ⥭ 室 ⮢.
 * Message tables creating.	       ⠡窨 ᠣ.
 *
 */

#include "./sqw-inc.h"

void Sqw_pr(void);
void LogPktLine(int, int, char *);
int Add_Sqwacr(char *, int, int);
void Pse_Check(unsigned int, unsigned long, int);
unsigned int GetInt(int *);

/* ========================================================================= */
#define Skip_EOL()  while((c0!=0)&&(c0!='\n')&&(c0!='\r')&&(c0!=EOF)) {c1 = c0; c0=fgetc(filepkt);}
#define UUE_Check() Chk_UUE(&c0)

#define Kludge_Check(A) Chk_Kludge(&c0,A)
int Chk_Kludge(int *c0, char *s);
int Chk_UUE(int *c0);
void LogPktLine(int, int, char *);

extern ADDR huge *Lin;

/*************************** Data for all functions **************************/
int	right_Dest,	     /*  ᮢ ,   - 	*/
	right_Orig;	     /*  襫    	*/
static	char	s_to_be_read[] = "s to be read";

void Sqw_pr()
{
int	c0,c1;
unsigned short int DestPoint;		/* १   PKT  */
char	*tag_now;			/* ⠣ ⥪饣 ᮮ饭	    */
int	ferror_filepkt; 		/*  訡 ⥭	    */
unsigned long pkt_pos;			/*  室 	    */
char	PKT_Type;			/* ⨯ 室  (2.?)	    */
int	res = 0,			/* ਧ 宣 ਤ	     */
	pse = 0;			/* ਧ  ⮣   ਤ */
char	wbd_pkt = WBD_UNKNOWN;		/* ਧ What Bad?       */
/* ================= Executive code ======================================= */
tag_now = malloc(MAXTAGLEN+2);		/*  ⠣ ⥪饣 ᮮ饭    */
MSG_Num = 0;

sprintf(Buffer, "First pass started, %u packet%s",
					PKT_Num, s_to_be_read);
OutLog (LEV_TRIV, Buffer);

/* -------------------------  横 ᬮ ⮢ --------------- */
for (pktnum = 0; pktnum < (char)PKT_Num; pktnum++)
    { unsigned int result; register unsigned int i;
    printf ("%s ",PKTFile[pktnum] + (unsigned int)Inb_Len);
    wbd_pkt = WBD_UNKNOWN;
    filepkt = fopen (PKTFile[pktnum],rb);
    if	(filepkt)
	 {
	 setvbuf(filepkt,Buf_Pkt,_IOFBF,Cfg_BufSize);
	 result = fread (&ph, sizeof(ph), 1, filepkt);
	 }
    else {
	 LogPktLine(4, pktnum, "Strange! Can't open file!");
	 continue;
	 }

    if ((!result) || (ph.packettype != 2))
	 {
	 if (ferror(filepkt)) LogPktLine(5, pktnum, Read_Error);
	 else LogPktLine(5, pktnum, "Short/bad hdr");
	 fclose (filepkt);
	 RenameEXT(PKTFile[pktnum], Lin_BAD);
	 continue;
	 }
    else;
/*-----------------------------------------------------------------------
Packet seems to be type-2 and right     ⨯ 2  ࠢ
------------------------------------------------------------------------*/
    PKTOrg[pktnum].Zone  = ph.origZone;
    PKTOrg[pktnum].Node  = ph.origNode;
    PKTOrg[pktnum].Net	 = ph.origNet;	 /* ###014  ⠢... */
    PKTOrg[pktnum].Point = 0;
    if (ph.baud == 2)
	{				/* FSC-0045.001 compatibility */
	PKTOrg[pktnum].Point = ph.year;
	DestPoint = ph.month;
	PKT_Type = '2';
	}
    else /* 2.0, 2+ packets */
	{				/* FSC-0048.002 compatibility */
	if (ph.origNet == 65535L)
	   if (ph.origPoint) PKTOrg[pktnum].Net = ph.auxNet;
/*+ This else is NOT described in FSC!!!    else  ᠭ  FSC!!! */
	   else PKTOrg[pktnum].Net = ph.origNet;
/*- I decided to set it to origNet.	  訫 ⠭  origNet	     */
/*  May be FakeNet option  will  be   ,  FakeNet a   㯮- */
/*  more useful - thinking...	      pe⥫쭠 - 㬠...		     */
	else;
	right_Dest = (ph.CapWord >> 8);
	DestPoint  = (ph.CapWord << 8) + right_Dest;
						/* 祭 ᢠ⮥ ᫮ */
	if ((ph.CapValid == DestPoint))
	    {					/* ᫨  Stone Age	    */
	    DestPoint = ph.destPoint;
	    PKTOrg[pktnum].Point = ph.origPoint;
	    PKT_Type = '+';
	    }
	else{					/* ᫨ Stone Age	   */
	    DestPoint = 0;
	    PKTOrg[pktnum].Point = 0;
	    PKT_Type = '0';
	    }
	}
    right_Dest=0;		/*     DestNode - ?	*/
    PKTDest[pktnum].Zone  = ph.destZone;
    PKTDest[pktnum].Net   = ph.destNet;
    PKTDest[pktnum].Node  = ph.destNode;
    PKTDest[pktnum].Point = DestPoint;
    for (i=0; i < My_Addr_Num; i++)
	{
	if (ph.destZone  != My[i].Zone)  continue; else;
	if (ph.destNet	 != My[i].Net)	 continue; else;
	if (ph.destNode  != My[i].Node)  continue; else;
	if (DestPoint	 != My[i].Point) continue; else;
	right_Dest = 1;
	break;
	} /* for i< My_Addr_Num -   */

    if ((!right_Dest) && Cfg_Secure)			/* ###053 */
	   if (!Cfg_SecureNotRename)
		{
		LogPktLine(5, pktnum, "Packet not for us. Renamed");
		fclose (filepkt);
		RenameEXT(PKTFile[pktnum], Lin_SEC);
		continue;
		} /* if (!SecureNotRename) */
	   else wbd_pkt = WBD_NOTFUS;
    else
     {
     right_Orig=0;	/*     origNode	*/
     for (i=1; i <= Link_Num; i++)
	{
	if (PKTOrg[pktnum].Zone  != Link[i].Zone)  continue; else;
	if (PKTOrg[pktnum].Net	 != Link[i].Net)   continue; else;
	if (PKTOrg[pktnum].Node  != Link[i].Node)  continue; else;
	if (PKTOrg[pktnum].Point != Link[i].Point) continue; else;
	right_Orig = 1;
	break;
	} /* for i<= Link_Num -    */
     result = i;	/*     ᮮ饭  */
/*------- ஢ઠ ஫   ------------------------------------*/

     if  ((result <= Link_Num) && Link[result].PKTPassword[0])
	{
	unsigned char *s0 = ph.password, *s1 = Link[result].PKTPassword;
	int i = 8, Right_Orig;

	do Right_Orig = (*s0++ == *s1++); while(Right_Orig && (--i));
	if (!Right_Orig)
	   {
	   if (!Cfg_SecureNotRename)
		{
		LogPktLine(5, pktnum, "Packet Password Error. Renamed");
		fclose (filepkt);
		RenameEXT(PKTFile[pktnum], Lin_SEC);
		continue;
		} /* if (!Cfg_SecureNotRename) */
	   else if (ph.password[0]) wbd_pkt = WBD_PASSWD;
		else wbd_pkt = WBD_NOPASS;
	   }/* if (!Right_Orig) */
	 else;
	 } /*  if  ((result <= Link_Num) && Link[result].PKTPassword[0]) */
     else;
     } /* else (!right_Dest) */
/***************************  ᬮ ᮮ饭   **********/
    for (i = MSG_Num; i < MSG_Max; i++)
	{
	int	to_break = 0;	/* ਧ 뢠  横 */
	Msg[i].Area   = AREANET;
	Msg[i].Link   = result;
#if (AREAFIX_STYLE || AREAFIX_IN_ECHOES)
	Msg[i].AFIX = 1;
#endif
	Msg[i].PKT    = pktnum;
	Msg[i].Reply  = 0;
	Msg[i].Offset = ftell(filepkt);
	Msg[i].OffTear = 0;
	Msg[i].OffOrig = 0;
	Msg[i].OffSeen = 0;
	Msg[i].OffPath = 0;
	Msg[i].WhatBad = wbd_pkt;
	if (i && !Msg[i-1].Length)
	   Msg[i-1].Length = Msg[i].Offset - Msg[i-1].Offset;
	else;
	Msg[i].Length = 0;
	Msg[i].DupeID = 0;
	Msg[i].UUElines = 0;
	Msg[i].rule = Cfg_RulesExtract;
	Msg[i].INTL = 0;
	Msg[i].DOMAIN = 0;
	Msg[i].MSGID = 0;
	Msg[i].dMy   = 0;
	Msg[i].oZone = (unsigned short int)(-1);
	Msg[i].dZone = (unsigned short int)(-1);
	c1 = fread (&mh, 1, sizeof(mh), filepkt);
	Msg[i].oNet   = mh.origNet;
	Msg[i].oNode  = mh.origNode;
	Msg[i].dNet   = mh.destNet;
	Msg[i].dNode  = mh.destNode;
	Msg[i].oPoint = 0;
	Msg[i].dPoint = 0;
	switch	(c1)
		{
		case sizeof(mh): /* ଠ쭮 砫  ᠣ */
/* ============   ᮮ饭 =============================== */
		if (mh.PakdMessage == 2)
		   {
		   unsigned int first_line;
/* --------------- ஫    ᮮ饭   ---- */
		if (Cfg_CorrectDate==2)
		   {
		   switch (Cfg_CheckDate)
			{
			case 1:
			if (Chk_Line(mh.DateTime,"Fae  0 Aab  0  0:00",
						 "Tuu 39 Suy 99 29:59", 20)) break;
#if 0
/*
 * During all time SqWish  exists I
 * never  received  reports   about
 * these situations.  If  you  have
 * links with such strange date fi-
 * elds of messages to be generated
 * - report to me, please!
 */

		/* ᮮ⢥⢨ ࠧ ଠ⠬ */
			if (Chk_Line(mh.DateTime," 0 Aab  0  0:00:00\0",
						 "39 Suy 99 29:59:59\0", 20)) break;
			if (Chk_Line(mh.DateTime," 0 AAB  0   0:00:00",
						 "39 Suy 99  29:59:59", 20)) break;
			if (Chk_Line(mh.DateTime,"0 Aab  0   0:00:00\0",
						 "9 Suy 99  29:59:59\0", 20)) break;
			if (Chk_Line(mh.DateTime,"00:00:00\0",
						 "29:59:59\0", 9)) break;
			if (Chk_Line(mh.DateTime," 0 Aab  0  0:00\0",
						 "39 Suy 99 29:59\0", 17)) break;
			if (Chk_Line(mh.DateTime,"00/00/00 00:00:00\0",
						 "19/39/99 29:59:59\0", 19)) break;
			if (Chk_Line(mh.DateTime,"00/00/0000 00:00:00",
						 "19/39/9999 29:59:59", 20)) break;
/**************************************************************************/
#endif
			case 2: /* ᮮ⢥⢨ ⮫쪮 FTS    */
			if (Chk_Line(mh.DateTime,"00 Aab 00  00:00:00",
						 "39 Suy 99  29:59:59", 20)) break;
				Msg[i].WhatBad = WBD_MSGDATE;
				Msg[i].Area = AREABAD;
			default: break;
			} /* switch (Cfg_CheckDate) */
		   } /* if (Cfg_CorrectDate==2) */
		else;
/* --------------- ஫    ᮮ饭  "100"  ----- */
		if (Chk_Line(mh.DateTime, "00 Aab 100  00:00:00",
					  "39 Suy 999  29:59:59",20))
		   {
		   Msg[i].WhatBad = WBD_MSGDATEY2K;
		   Msg[i].Area = AREABAD;
		   c0 = fgetc(filepkt);	/* skip 21st byte of DateTime field */
		   }
		else;
/* --------------- ஫    ᮮ饭  "0"  ------- */
		if (Chk_Line(mh.DateTime, "00 Aab 0  00:00:00",
					  "39 Suy 9  29:59:59",19))
		   {
		   Msg[i].WhatBad = WBD_MSGDATEY2K;
		   Msg[i].Area = AREABAD;
		   ungetc(mh.DateTime[19], filepkt); /* return 1 byte     */
		   }
		else;
/* ---------------------------------------------------------------------- */
		   crc = 0;
		   for (first_line = 0; first_line < 20; first_line++)
			crc = CRC_ADD (mh.DateTime[first_line], crc);
		   rgx_Line(&c0, i, HASH_RulesTo);
		   rgx_Line(&c0, i, HASH_RulesFrom);
		   rgx_Line(&c0, i, HASH_RulesSubj);
		   to_break = 0;
/* --------------- ⥫ ᮮ饭 --------------------------------------- */
		   first_line = 1;
		   c0 = EOF;
		   res = 0;
		   pse = 0;
		   do {/* while to_break == 0 */
		      unsigned long	OffSet_Now = ftell(filepkt);
/*
 * c0 -  ᨬ ப
 *
 * !  ⠪ ,    ᠣ  \r -  ⮬ 砥
 * \0 뢠 ⠭  c0  ।饬 室 横 while to_break
 * ( ⮬  뢠  -   DupeID   ⠡,
 * ⠢ ...). ⮬  ⠥ ᨬ ⮫쪮 ᫨
 * ।騩   \0.  ⮡ ᫥ 奤  c0  﫨 - । 横
 * ⮨ c0=EOF.  ᮮ饭 SQUISH 1.01 ਭ ᮢ襭 ଠ쭮,
 *   ᭮   ਭ... ;-)
 *
 */
		      if (c0) c0 = fgetc(filepkt); else;
		      switch (c0)
			{
			case 0: 	/* End of message -		  */

/* ᫨   ᠣ  ᫨  DupeID -  Message Header'a    */
			   if (!Msg[i].DupeID) Msg[i].DupeID = crc; else;
			case EOF:	/* End of file			  */
			   if (ferror(filepkt))
				LogPktLine(5, pktnum, Read_Error);
			   else;
/* < - - - - - ਭ⨥ 襭  宩 ᠣ   - - - - - - - - - */
to_break = 1;
if ((Msg[i].oZone == 0) || (Msg[i].oZone == (unsigned short int)(-1)))
   Msg[i].oZone = ph.origZone; else;
if (Msg[i].oZone == 0) Msg[i].oZone = My[0].Zone; else;
if ((Msg[i].dZone == 0) || (Msg[i].dZone == (unsigned short int)(-1)))
   Msg[i].dZone = Msg[i].oZone; else;

#if (AREAFIX_STYLE)

if (((Msg[i].Area == AREAFIX) || Msg[i].AFIX) &&
    (Msg[i].Length >= MINSEENBY))
    {
    Msg[i].Area = AREABAD;
    Msg[i].WhatBad = WBD_AF_LONG;
    }
else;

/* Check if destination address of AREAFIX message is our address */
if ((Msg[i].Area == AREAFIX) || Msg[i].AFIX)
   { unsigned short int right_Dest = 0, k;
   for (k=0; k < My_Addr_Num; k++)
	{
	if (Msg[i].dZone  != My[k].Zone)  continue; else;
	if (Msg[i].dNet   != My[k].Net)   continue; else;
	if (Msg[i].dNode  != My[k].Node)  continue; else;
	if (Msg[i].dPoint != My[k].Point) continue; else;
	right_Dest = 1;
	break;
	} /* for k < My_Addr_Num -   */
   if (!right_Dest) Msg[i].Area = AREANET; else Msg[i].dMy = (char)k;
   }
else;
#endif

if (Msg[i].Area >= AREA1ST)
   {
#if (AREAFIX_STYLE || AREAFIX_IN_ECHOES)

   if (Cfg_PointSecure && Msg[i].AFIX)
      {
      Msg[i].AFIX = 0;
      Msg[i].Area = AREAPSE;
      Msg[i].WhatBad = WBD_AF_ECHO;
      break;
      }
   else;
#endif /* (AREAFIX_STYLE || AREAFIX_IN_ECHOES) */

   if (pse && (Msg[i].WhatBad != WBD_UNKNOWN))	/* ᫨ WhatBad 㦥 */
	{
	Msg[i].Area = AREAPSE;
	break;
	}
   else;

   pse = ((Cfg_PointSecure >= PSE_CHECK_ALL) && Link[Msg[i].Link].Point);

   /*  SEEN-BY  ᠣ,      ⪫祭 ஢ઠ */
   if ((Link[Msg[i].Link].SBValid != 1) && (Msg[i].OffSeen == 0))
      { Msg[i].Area = AREABAD; Msg[i].WhatBad = WBD_SEENBY; break; } else;

   /*  ਤ -  OriginValid 0,1 -   */
   /* V03.08+                               ⮨ < 2  != 2 */
   if  ((Msg[i].OffOrig == 0) && ((Link[Msg[i].Link].ORValid < 2) || pse))
      { Msg[i].Area = AREABAD; Msg[i].WhatBad = WBD_ORIGIN; break; } else;

   /* ਤ   ,  OriginValid 1,2 -   */
   if (res &&  ((Link[Msg[i].Link].ORValid == 1) ||
		(Link[Msg[i].Link].ORValid == 2) || pse))
      { Msg[i].Area = AREABAD; Msg[i].WhatBad = WBD_ORIGVAL; break; } else;

   /*  ⥠ૠ */
   if ((!Msg[i].OffTear) && ((!Cfg_TearLineExist) || pse))
      { Msg[i].Area = AREABAD; Msg[i].WhatBad = WBD_NOTEAR; break; } else;

   pse = ((Cfg_PointSecure == PSE_SEEN_PATH) && Link[Msg[i].Link].Point);

   if (pse && Msg[i].OffSeen) Pse_Check(i, OffSet_Now, 0); else;
   if (pse && Msg[i].OffPath) Pse_Check(i, OffSet_Now, 1); else;
   } /* if (Msg[i].Area >= AREA1ST) */
else;
break;
/* >-------------------------> - - - - - - - - - - - - - - - - - - - - -  */
			case 1: 	/* Ctrl-A kludges first 	  */
			     c0 = fgetc(filepkt);
			     if ((!Msg[i].DupeID) && (Kludge_Check("MSGID: ")))
				{ long offkeep = ftell(filepkt);
				Msg[i].DupeID = crc_line(&c0);
				if (Msg[i].oZone == (unsigned short int)(-1))
				   { long offkeep2 = ftell(filepkt);
				     int c1;
				   fseek (filepkt, offkeep, SEEK_SET);
				   Msg[i].oZone = GetInt(&c1);
				   if (c1 != ':') goto NotFTNMSGID;
				   Msg[i].oNet = GetInt(&c1);
				   if (c1 != '/') goto NotFTNMSGID;
				   Msg[i].oNode = GetInt(&c1);
				   if (c1 == '.') Msg[i].oPoint = GetInt(&c1);
				   else;
				   if (c1 == '@') do c1 = fgetc(filepkt);
					while ((c1 != ' ') && (c1 != EOF) && (c1));
				   else;
				   if (c1 != ' ') goto NotFTNMSGID;
				   else;
				   if ((mh.origNet == Msg[i].oNet) &&
					(mh.origNode == Msg[i].oNode))
					{
					Msg[i].dZone = Msg[i].oZone;
					Msg[i].MSGID = 1;
					}
				   else;
			NotFTNMSGID:
				   fseek (filepkt, offkeep2, SEEK_SET);
				   } /* (Msg[i].oZone == -1) */
				else;
/* , ᤥ  ࠧ祭   宬, ࠧ 
    ࠢ -㭪  31-,   32- 祭 */
/* ###017 */			if (Msg[i].Area == AREANET)
				   Msg[i].DupeID |= 0x80000000L;
				break;
				}
			     if (Kludge_Check("PATH: "))
				{
				if (Msg[i].OffPath == 0)
					Msg[i].OffPath = OffSet_Now;
				else;
				Skip_EOL(); break;
				}
/* 祭    Reply  襣  */
			     if (Kludge_Check("REPLY: "))
				{ char buffer[80], *s1=buffer;
				  int	j = 0;
				do buffer[j++] = (char)(c0 = fgetc(filepkt));
				while ((c0) && (c0 != EOF)
				    && (c0 != '\r') && (c0 != '\n')
				    && (c0 != ' ')  && (j < 78));
				buffer[j] = '\0';
				s1 = buffer;
				Lin = (ADDR *)(&Link[0]);
				if (Sqw_adr((char **)&s1))
				   { int arorigin = Area[Msg[i].Area].Org;
				   if  ((My[arorigin].Zone == Link->Zone) &&
					(My[arorigin].Net  == Link->Net) &&
					(My[arorigin].Node == Link->Node))
				       Msg[i].Reply = Link->Point;
				   else;
				   }
				Skip_EOL(); break;
				} /* if Kludge_Check REPLY */
			     if (!Msg[i].DOMAIN && Kludge_Check("INTL: "))
				{
				Msg[i].oZone = GetInt(&c0);
				if (c0 != ':') goto Err_Intl;
				Msg[i].oNet = GetInt(&c0);
				if (c0 != '/') goto Err_Intl;
				Msg[i].oNode = GetInt(&c0);
				if (c0 == '@')
					do c0 = fgetc(filepkt);
					while ((c0 != ' ') && (c0 != EOF) && (c0));
				else;
				if (c0 != ' ') goto Err_Intl;

				Msg[i].dZone = GetInt(&c0);
				if (c0 != ':') goto Err_Intl;
				Msg[i].dNet = GetInt(&c0);
				if (c0 != '/') goto Err_Intl;
				Msg[i].dNode = GetInt(&c0);
				Msg[i].INTL = 1;
			Err_Intl:
				Skip_EOL(); break;
				} /* if (Kludge_Check("INTL: ")) */

			     if (!Msg[i].DOMAIN && Kludge_Check("FMPT "))
				{
				Msg[i].oPoint = GetInt(&c0);
				Skip_EOL(); break;
				} /* if (Kludge_Check("FMPT ")) */
			     if (!Msg[i].DOMAIN && Kludge_Check("TOPT "))
				{
				Msg[i].dPoint = GetInt(&c0);
				Skip_EOL(); break;
				} /* if (Kludge_Check("TOPT ")) */
			     if (Kludge_Check("DOMAIN: "))
				{

				Msg[i].DOMAIN = 1;
/*			Err_DOMAIN:
*/
				Skip_EOL(); break;
				} /* if (Kludge_Check("DOMAIN: ")) */

/* ࠡ⪠  SPLIT  㯮 ( ᯫ⮢ ᠣ 諨) */
/*+*/			     if (Cfg_CheckSplit && (Kludge_Check("SPLIT: ")))
				{
				Msg[i].SplitID = crc_line(&c0);
				Skip_EOL();
				break;
				}
/*-*/			     Skip_EOL(); break;
			case 'S':
			     if (Kludge_Check("SEEN-BY: "))
				if (Msg[i].OffSeen == 0)
					Msg[i].OffSeen = OffSet_Now;
			     else {
				  Msg[i].UUElines += UUE_Check();
				  break;
				  }
			     Skip_EOL(); break;

/* ###003 */		case '-': if (((c0 = fgetc(filepkt)) == '-')
/* ᫥ ⨠ૠ	       */  && ((c0 = fgetc(filepkt)) == '-'))
/* 㤥 窮 砭      */	{
/* ⥪ ᠣ	       */	Msg[i].OffTear = OffSet_Now;
/* 祬    */	Msg[i].OffOrig = 0;
/* ࠭ 祭 Origin,   */	Msg[i].OffSeen = 0;
/* SEEN-BY  PATH	       */	Msg[i].OffPath = 0;
					Skip_EOL();
					break;
					}
				else	{
					Msg[i].UUElines += UUE_Check();
					break;
					}
			case ' ':
/*   ------------{ 			   ஢ઠ ਤ */
if (
					/* ###004 ਤ ᫥ ⥠ૠ!   */
    (Cfg_TearLineExist || Msg[i].OffTear) &&
    (Msg[i].Area >= AREA1ST) && 	/* ###010  㡨  PointSec */
    (Kludge_Check (" * Origin: ")))

   {	 int offaddr = (int)(ftell(filepkt) - OffSet_Now);
	 unsigned char buffer[89], *s1 = buffer;
	 int j = 0;

   Msg[i].OffOrig = OffSet_Now;
   Msg[i].OffSeen = 0;			/* ⨢訩 ਤ  -  */
   Msg[i].OffPath = 0;			/* 묨 ० SEEN-BY  PATH  */
   Msg[i].offAddr = 0;
   Msg[i].lenAddr = 0;
   *s1++ = (char)c0; j++;		/* ###041 */
   while ((j < 82) && (c0) && (c0 != EOF) &&
		      (c0 != '\r') && (c0 != '\n'))
	{ *s1++ = (char)(c0 = fgetc(filepkt)); j++; }

   *s1 = '\0';
   if ((j >= 82) || (buffer[j-2] != ')')) res = 1;
   else {
	do j--; while ((j > 0) && !isdigit(buffer[j]) && (buffer[j] != '('));
	if ((buffer[j] == '(') || (j <= 0)) res = 1;
	else {
	     buffer[j+1] = '\0';
	     do j--; while ((j > 0) && (buffer[j] != '('));
	     if (j <= 0) res = 1;
	     else do j++; while (!isdigit(buffer[j]));
	     s1 = buffer + j;
	     Msg[i].offAddr = offaddr + j - 1;
	     } /* else ((buffer[j] == '(') || (j <= 0)) */
	} /* else ((j >= 82) || (buffer[j-2] != ')')) */
   if (!res) { unsigned char *s2 = s1; int c1;
	     do {
		Msg[i].lenAddr++;
		c1 = *s2++;
		}
	     while (c1);

	     Lin = (ADDR *)(&Link[0]);
	     if (Sqw_adr((char **)&s1))
		   {
		   res = Msg[i].Link;
		   pse = Cfg_PointSecure && Link[res].Point &&
/*  ஢ ᮢ     */	((Link->Zone  != Link[res].Zone)||
/*   ਤ    */	 (Link->Net   != Link[res].Net)||
/* ᫨  ᮢ,  - ,  */	 (Link->Node  != Link[res].Node));
/* 祭 PointSecure -  .PSE    */
/*     ஢!  졠 ⥫⥫ */
		   if (pse) Msg[i].WhatBad = WBD_ORIGAD; else;
		   res = 0;
		   } /* if Sqw_adr */
	     else  {
		   res = 1; /*    -   BAD! */
		   Msg[i].WhatBad = WBD_ORIGIN;
		   } /* else Sqw_adr */
	     } /* if !res char buffer[] int j */
	else;
	if (res)
	   {
	   Msg[i].OffTear = 0;	   Msg[i].OffOrig = 0;	   Msg[i].OffSeen = 0;
	   Msg[i].OffPath = 0;	   Msg[i].offAddr = 0;	   Msg[i].lenAddr = 0;
	   }
	else;
	res = Link[Msg[i].Link].ORValid && res;
   } /* if Kludge_Check Origin	int res, pse */
else	{
	Msg[i].OffTear = 0;
/*   ^  ப  ஡ ।   ⥠ૠ  ! */
	if (UUE_Check())
		Msg[i].UUElines++;
	else;
	} /* else if Kludge_Check Origin  int res, pse */
break;
/*   ------------} 			   ஢ઠ ਤ */
			case 'A':       /* AREA:? */
/* <---  	------{ */
if (first_line) 			/*... only as first line? */
   {
   first_line = 0;
   if (Kludge_Check ("AREA:"))          /* ᫨  xᠣ */
	{ int readen = 0, arnum;
	char *sptr = tag_now;
	while (readen++ <= MAXTAGLEN + 1) /*  ⠣  tag_now */
	   {
	   *sptr = (char)(c0 = fgetc (filepkt));
	   if (c0 == ' ') continue; else;
	   if (IsMsgEOL(c0)) break; else sptr++;
	   } /* while (readen++ <= MAXTAGLEN + 1) */
	*sptr='\0';
	arnum = Find_Tag(tag_now, readen-1);
	if (!arnum)
	   {
	   Msg[i].Area = AREANEW;
	   if (Add_Sqwacr(tag_now, readen-1,Msg[i].Link) == EOF)
		OutLog(LEV_WARN, "NewAreasCreate 2 failed. Switched to 0");
	   else;
	   }
	else /* !arnum ###056 */
	   { unsigned long offf =
		(unsigned long)(arnum) * Link_Num + Msg[i].Link;
	   if ((arnum >= AREA1ST) && (Msg[i].Area != AREABAD))
	      {
	      if (Cfg_Secure && ((AreaLink[offf] & ALUP) == 0))
		{
		if (Msg[i].WhatBad == WBD_UNKNOWN) Msg[i].WhatBad = WBD_SECURE;
		else;
		Msg[i].Area = AREASEC;
		}
	      else Msg[i].Area = arnum;
	      }
	   else;
	   } /* else !arnum long offf */
/* - ஢ઠ    ᮮ饭 ६饭  砫  - */
	break;
	} /* if (Kludge_Check ("AREA:")) int readen = 0, arnum; char *sptr */
   else;
   }  /* if first_line */
else;
/* >---  	------} */
			default:	/* No Ctrl-A or AREA: first line  */
					/* Means mesage body - skip to \n */
			   first_line = 0;
			   if (UUE_Check())
				Msg[i].UUElines++;
			   else;
			}/* switch (c0=fgetc...) */
		      }
		   while (to_break == 0);
		   if (c0 == EOF) {puts (crashed_last_msg); break;}
		   else;
		   to_break = 0;
		   break;
		   } /* if mh.PakdMsg == 2 */
		else {
		     LogPktLine (4, pktnum, Strange_After);
/* ⠢  碥 TossAfterZeroes -   ஢ન  㠫
⮫쪮  쭥襬 ७ ⮩  */
		     if (Cfg_TossAfterZeroes == 1)
			{
			fseek (filepkt,0L,SEEK_END);
			Msg[i].Area = AREABTL;
			Msg[i].WhatBad = WBD_TAIL;
			}
		     else to_break = 1;
		     }
		break;
/**************  ࠧ  ᮮ饭 *************************/
		case 2:
		     if (mh.PakdMessage == 0)
			{
			to_break = 1;
			break;
			}
		     else;
		case 1: 	/* ࢠ .  ᠣ 楫  */
		case 0: 	/* switch c1 (as result of fread)      */
		     LogPktLine (1, pktnum, End_Of_Pkt_012);
		     to_break = 1;
		     break;

		default:	/* 뢮  ᠣ   */
		     LogPktLine (4, pktnum, Strange_After);
		     Msg[i].WhatBad = WBD_PACKET;
		     if (Cfg_TossAfterZeroes == 1) Msg[i].Area = AREABTL;
		     else to_break = 1;
		     break;
		}/* switch c1 (as result of fread) */
	Msg[i].Length = ftell(filepkt) - Msg[i].Offset;
	if (to_break) break; else;
	} /* for i = Msg_Num */
/***************************  横 ᬮ ᮮ饭   ***/
   if (ferror(filepkt))
	{
	LogPktLine (5, pktnum, Read_Error);
	ferror_filepkt = 1;
	}
    else ferror_filepkt = 0;
    fseek (filepkt,0L,SEEK_END);
    pkt_pos = ftell(filepkt);
    fclose (filepkt);
    if (!ferror_filepkt && (i < MSG_Max))	/* ᫨  ଠ쭮	*/
	{ unsigned long tmp = (unsigned long)Msg[i].Offset+Msg[i].Length;
	sprintf (Buffer,
		"%.8s (2.%c %lub): %hu:%hu/%hu.%hu -> %hu:%hu/%hu.%hu; %u msgs",
		PKTFile[pktnum]+(unsigned int)Inb_Len, PKT_Type, tmp,
		ph.origZone, PKTOrg[pktnum].Net, ph.origNode, PKTOrg[pktnum].Point,
		ph.destZone, ph.destNet, ph.destNode, DestPoint, i-MSG_Num);
	puts (Buffer + 9);
	OutLog (LEV_USEFUL, Buffer);
	MSG_Num = i;
	}
    else		/* ᫨ ॢ襭 ⢥  ᠣ  */
	{
	if (pktnum == 0)
		{	/* ᫨  墠⨫   ⢥  */
			/*   ⢥   ⠥	*/
		if (ferror_filepkt)
		     RenameEXT(PKTFile[pktnum],Lin_BAD);
		else {	/* ⠢  ⠢襣 墮	*/
		     Msg[i-1].Area = AREARST;
		     Msg[i-1].Length = pkt_pos - Msg[i-1].Offset;
		     }
		MSG_Num = i;
		}
	else	{	/* ᫨  ।  ॢ襭 	*/
			/*   ⠫  - २  */
			/*  ᫥騥 ⭮  .PKT -   .~KT -*/
			/* 					*/
		for (i=pktnum; i < PKT_Num; i++)
		    RenameEXT(PKTFile[i],Lin_PKT);
/* ###007  﫮 pktnum,   i ^ */
/* - 祣 﫨 ,  २뢠. */
		PKT_Num=pktnum;
		}
	}/* else i < MSG_Max && !ferror_filepkt */
    } /* for (pktnum = 0; pktnum <= PKT_Num, pktnum++) */
sprintf (Buffer, "Second pass started, %u message%s",
		MSG_Num, s_to_be_read);
OutLog (LEV_USEFUL, Buffer);
puts(Buffer);
free(tag_now);
} /* Sqw_pr() */

int Chk_Line (unsigned char *line,
	      const char *match0,
	      const char *match9,
	      unsigned int length)
{
while (length-- != 0)
      if ((*match0++ > *line) || (*line > *match9++))
	 return 0;
      else line++;
return 1;
} /* Chk_Line() */

/* ------- 㭪 ࠢ ⥪饣 ⮪   ப ----------- */

/* .  Kludge_Check()

   ᭮     ⮬,    㥬 
   稭  ࠧ 㪢, 楯窠 ஢ப 室 ଠ쭮. ᫨ 
   ⮩ 㭪樥 ஢ , 稭騥   㪢,  
   "ꥤ"  ,   ன ࠢ쭮.  :

c0 = fgetc(filepkt);
   Kludge_Check("PATH: ");
   Kludge_Check("SEEN-BY: ");

⨬ ;   ⠪:

c0 = fgetc(filepkt);
   Kludge_Check("REPLYTO: ");
   Kludge_Check("REPLYADDR: ");

  -  ஢ ஬   ப "ADDR: "
----------------------------------------------------------------------------*/
int Chk_Kludge (int *c0, char *line)
{
do {
/*  ࠢ  ஢ ⢨    */
   if ((*c0 == ' ') && (*line == ':')
      && (*(line-1) != ' ') && (*(line+1) == ' ')) line++;
/* ᫨  ᮢ ப -   */
   if ((char)(*c0) != *line++) return 0;
/* ᫨ ᮢ -   */
   if (*line == '\0') return 1;
/*  ᫥騩 ᨬ  䠩 */
   *c0 = fgetc(filepkt);
   }
while (*c0 != EOF);
return 1;
} /* Chk_Kludge() */

/* Check line for UUE-style (no spaces, length equal to previous) */
int Chk_UUE(int *c0)
{
static int UUE_prev = 0;
int UUE_count = 0;

while((*c0!=0)&&(*c0!='\n')&&(*c0!='\r')&&(*c0!=EOF))
	{
	if ((*c0 <= '~') && (*c0 >= '!')) UUE_count++;
	if (*c0 == ' ') UUE_count = 0;
	*c0=fgetc(filepkt);
	}

if ((UUE_prev > Cfg_MinUUEline) && (UUE_prev == UUE_count)) return 1;
else { if (UUE_count) UUE_prev = UUE_count; else; return 0;}
}

/* ======================================================================== *
 * NewAreasCreate:
 * 0 - No action		        祣.
 * 1 - adds line to sqwacr_bat.        ப  sqwacr.bat.
 * 2 - adds echotag to New_Lin.        ⠣  New.
 *
 * Returns:			      頥:
 * 0 - Not added to normal reason.    祣  ᤥ.
 * 1 - Tag is already in New.	      ⠣ 㦥   New.
 * 2 - added tag successfully.	      ⠣  ᯥ譮.
 * 3 - Can't add. No memory/IO Err.    墠⠥   訡 /.
 * (switched to 0, next  running of   (४砥 	NewAreasCreate	0,  
 * sqwish on the .onw moved to	in-   ᫥饬 ᪥ sqwish'a  ६
 * bound as .pkt will continue this    㭤 .onw  ࠡ⠭  -
 * work without problems).	       ஡).
 *
 * EOF - Can't begin New. No Memory.
 * ------------------------------------------------------------------------ */

int Add_Sqwacr(char *tag, int len, int link)
{
int retval = 0;
static int  cfg_newareascreate = -1;
static char tag_prev[MAXTAGLEN+1] = {0}; /* ###055 */

#if AREAFIX_STYLE
static	NEW huge *old;
	NEW huge *new;
#endif /* AREAFIX_STYLE */

FILE *fileout;
char straddr[28];
int i;

if (cfg_newareascreate == 0) return 0; else;

if (Link[link].Point) sprintf (straddr, Format_4D,
    Link[link].Zone, Link[link].Net, Link[link].Node, Link[link].Point);
else sprintf (straddr, Format_3D,
    Link[link].Zone, Link[link].Net, Link[link].Node);

#if AREAFIX_STYLE
if (!Link[link].AutoCre) return 0; else;

/* ---- If it is not first new tag - check if it is already exist here ---- */
new = New;
while(new) if (!strncmp(new->Line,tag,len)) return 1; else new = new->Next;
/* ---- allocation new NEW area ------------------------------------------- */
if ((Cfg_NewAreasCreate == 2) && (cfg_newareascreate != 0))
	{
	new = malloc(sizeof(NEW));
	if (new == NULL) goto No_Mem;
	else { new->Line = malloc(len + 2); new->Next = NULL; }
	if (new->Line == NULL)
	     {
No_Mem:
	     if (cfg_newareascreate == -1)
		{
		cfg_newareascreate = 0;
		return EOF;
		}
	     else return 3;
	     }
	else {
	     strncpy(new->Line,tag,(size_t)len); new->Line[len] = '\0';
	     new->Link = link;
	     if (cfg_newareascreate == -1)
		{
		cfg_newareascreate = Cfg_NewAreasCreate;
		old = New = new;
		}
	     else old->Next = new;	/* 䮬஢ 뫪  */
	     return 2;
	     } /* else (new->Line == NULL) */
	} /* if ((Cfg_NewAreasCreate == 2) && (cfg_newareascreate != 0)) */
else;
#endif /* AREAFIX_STYLE */

if (cfg_newareascreate == -1) cfg_newareascreate = Cfg_NewAreasCreate; else;


if (cfg_newareascreate == 1)
   {
   if ((len >= MAXTAGLEN) ||
       ((len + 4 + strlen(sqafix_create) + strlen(straddr)) > Cfg_MaxCommandLength))
	{
	sprintf (Buffer, "Too long areatag %.*s to be used in batch/script file",
			len, tag);
	OutLog (LEV_LOOSE, Buffer);
	return 0;
	}
   else;
   sprintf(Buffer,"%.*s", len, tag);            /* ###055 */
   if (strcmp(Buffer, tag_prev) == 0) return 0; /* ###055 */
   else strcpy(tag_prev, Buffer);		/* ###055 */

/* ###052.1/2 *
 *
 * This check is OS-aware. symbol "    ஢ઠ    -ᨬ.
 * is used with problems in DOS. It    窠 ஦ ஡  
 * means " is not valid  symbol  in   ᫨ ᯮ    ப  
 * areatag. Symbol "  in  UNIX  may   ⠢ ⠣.  UNIX    -
 * cause problems too, and must  be   ஢  ⮣, ⮡ ࠢ쭮 -
 * duplicated for using properly.     ਭ.
 *    Now I've setted tags  with  "     ⠭,  ⠣  -
 * not valid at all, regardless  to     묨 ᨬ 
 * OS.				      .
 *
 */
   for (i = 0; i < len; i++)
    if (tag[i] == '"')
	{
	sprintf (Buffer, "Areatag %.*s contains \" - not created", len, tag);
	OutLog (LEV_LOOSE, Buffer);
	puts (Buffer);
	return 0;
	}
    else;

   sprintf(Buffer,Format_ss,FlagD,sqwacr_xat);
   if ((fileout = fopen(Buffer,at)) != NULL)
	{
	fprintf (fileout, "%s %s \"%.*s\"\n", sqafix_create, straddr, len, tag);
	if (ferror(fileout)) { fclose(fileout); goto Ferr_Fout; }
	else fclose(fileout);
	return 2;
	}
   else {
Ferr_Fout:
	cfg_newareascreate = 0;
	sprintf (Buffer, "Can't open %s%s batch file for append",
				FlagD, sqwacr_xat);
	OutLog (LEV_LOOSE, Buffer);
	puts (Buffer);
	return 3;
	}
   } /* if cfg_newareascreate == 1 */
else;
return retval;
} /* Add_Sqwacr */

/* ⥫쭠 ஢ઠ SEEN-BY    PointSecure 3 ***************/
void Pse_Check (unsigned int i, unsigned long offset, int what_to_do)
{
unsigned long offkeep = ftell(filepkt);
unsigned char *s0;
unsigned short int net, node;
unsigned long length = 0;

*Buffer = '\0';
if ((Msg[i].OffPath == 0L) && what_to_do)
	return; /* PATH  ⢮ */
else;
if (what_to_do)
     {
     length = offset - Msg[i].OffPath;
     offset = Msg[i].OffPath;
     }
else {
     if (Msg[i].OffPath != 0L) offset = Msg[i].OffPath; else;
     length = offset - Msg[i].OffSeen;
     offset = Msg[i].OffSeen;
     }

if (length > MINSEENBY)
	{
	length = 0;
	OutLog (LEV_POSSIBLE,"Too long SEEN-BYs or PATHS");
	Msg[i].Area = AREABAD;
	if (what_to_do) Msg[i].WhatBad = WBD_PATHLO;
	else Msg[i].WhatBad = WBD_SEENLO;
	}
else	{
	fseek(filepkt,offset,SEEK_SET);
	fread (Buffer, (size_t)length, 1, filepkt);
	Buffer[(size_t)length] = '\0';
	Buffer[(size_t)length+1] = '\0';
	s0 = Buffer;

	do s0++; while ((*s0 != ' ') && *s0); /* skip SEEN-BY: or PATH: */
	if (next_addr(s0, &net, &node) == 2)	/* net/node form? */
	   {
	   do s0++; while ((*s0 != ' ') && *s0); /* skip seen-by to next */
	   if (next_addr(s0, &net, &node)) goto seen_mo_set; /* extra SEEN-BY? */
	   else {
		if ((net != Link[Msg[i].Link].Net) ||
		    (node != Link[Msg[i].Link].Node))
		    goto seen_mo_set;
		else;
		}
	   } /* if (next_addr == 2) */
	else
	   {
    seen_mo_set:
	   Msg[i].Area = AREAPSE;
	   Msg[i].WhatBad = WBD_SEENMO;
	   }
	} /* else Length >= MINSEENBY */
fseek(filepkt,offkeep,SEEK_SET);
} /* Pse_Check() */

/*   ⮪  頥 楫 ᫮ () */
unsigned int GetInt(int *c0)
{
char buffer[80];
int	j = 0;
do buffer[j++]=(char)(*c0=fgetc(filepkt));
while ((isdigit(*c0)) && (j < 78));
buffer[j] = '\0';
return (unsigned)atoi(buffer);
}
