/* sqwall.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * (C) 1998 Sergej Qkowlew     2:5020/122@fidonet		 ࣥ 
 *
 *				 V03.08
 *
 * Written for idiots who want	      ᠭ  ⮢,   㦥  -
 * 'All-In-One' tosser. !@#$%^.       ६ "--" . .
 *
 * Analyses  'squish-style' command       ப    ⨫
 * line and sequentially runs  nor-   squish'a  ᫥⥫쭮 ᪠ -
 * mal executables with appropriate   ଠ	譨    ࠬࠬ.  
 * params. DO NOT analyse config as    sqwish.cfg!
 * these executables!
 *
 * Errorlevels (global):	      ૥:
 *
 * 20? - can't execute some exe          -  exe
 * 200 - Incorrect cmd line params    ४ ࠬ  ப
 *   0 - All work is success.	       뫮 襭 ᯥ譮.
 *
 * Other errorlevels returned means    稥 ૥  ૥-
 * errorlevel of executed programm,    ᮮ⢥饩 饭  ணࠬ-
 * NOT sqwall.exe itself!	      ,   ᠬ sqwall.exe
 *
 * Distribution:		      ᮡ ࠭:
 * Source code under GNU license.      室 ⥪,  ࠬ GNU.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "./sqw-os.h"   /* OS-aware definitions */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define MAXARGS 20	/* ᨬ쭮 ⢮ 㬥⮢ args[]	    */

static char csqwish_cfg[MAXPATH]  = "-csqwish.cfg",
	    iinbound[MAXPATH]	  = "-i.\\",
	    ntossing_log[MAXPATH] = "-ntossing.log";

static int Line;
static char **args;

static	char *Lines[] = {
	"sqwarcx", "-ccompress.cfg", iinbound, ntossing_log, NULL,
	"sqwish", "-i.\\", csqwish_cfg, ntossing_log, NULL,
	"sqwacr", "@sqwacr.bat", csqwish_cfg, NULL,
	"sqafix", "AutoCreate", NULL,
	"sqwacr", csqwish_cfg, "-d", NULL,
	NULL
	};

int	System(void);

#if (defined(UNIX))

#include <sys/types.h>
#include <sys/wait.h>

static char movecommand[] = "mv";

#else /* UNIX */

static char movecommand[] = "move";

#include <process.h>

#endif /* else UNIX */


/* ============ ઠ  ப   c  ᨬ  ======= */
/*
void	strcpy2(char *s0, char *s1, char c, char *s2)
{
while (*s1) *s0++ = *s1++;
if (c) *s0++ = c; else;
while (*s2) *s0++ = *s2++;
*s0++ = '\0';
}
*/ /* void strcpy2(char *s0, char *s1, char *s2) */

/* ============================================================================
 * Invoke system command and return   맢 ⥬      
 * with errorlevel to be analysed.    祭  襭  .
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
int	System()
{
int k = 0, Summary = 0;

/* ------ Check summary length and path lengths in args -------------------- *
 * And do NOT tell me about 'no li-    ⮫쪮       ⢨
 * mits' in your OS!                  ࠭祭  襩 !
 * ------------------------------------------------------------------------- */
for (k = 0; k < MAXARGS; k++)
    {
    Summary += strlen(args[k]);
    if (args[k])
      {
      if(strlen(args[k]) > MAXPATH)
	{
	fputs ("Too long path ", stdout);
	puts(args[k]);
	return 200;
	}
      else;
      if (Summary > MAXCMDLEN)
	{
	puts("Too long command line built");
	return 200;
	}
      else;
      } /* if (args[k]) */
    else break;
    } /* for k < MAXARGS */

#if DEBUG
/**/while(args[k]) printf(" %s", args[k++]); puts(empty);
/**/fputs("System(); Press Enter to continue sqwarc executing>", stderr); getchar();
#endif

#ifdef UNIX
if(fork()) { wait(&k); k = WEXITSTATUS(k); }
else	{
	execvp(args[0], args);
	exit(200 + Line);
	}
#else /* UNIX */
k = spawnvp(P_WAIT, args[0], args);
#endif /* else UNIX */
return k;
}

/* ============================================================================
 * Returns 0 if success
 * Or result of System or unlink.
 * ------------------------------------------------------------------------- */

int Move (char *otkuda, char *kuda)
{

#ifdef UNIX

link(otkuda, kuda);
switch(errno)
	{
	case 0:
		if (unlink(otkuda)) return 1; else return 0;
	case EXDEV:    case EPERM:    case EMLINK:
/*
 * If link is impossible  for  some   ᫨  ᤥ  link    
 * reasons  -  shell command  mv is   稭 - 뢠  襫 mv.
 * invoked.
 */
		args[0] = movecommand;
		args[1] = otkuda,
		args[2] = kuda;
		args[3] = NULL;
		return (System());
	default:
		return 1;
	} /* switch errno */

#else	/*   ᮬ 襢 ࠧ  move */
		args[0] = movecommand;
		args[1] = "/Y";
		args[2] = otkuda,
		args[3] = kuda;
		args[4] = NULL;
		return (System());
#endif
} /* int Move() */

/* ===========  ணࠬ ========================================= */
void main (int argc, char **argv)
{
#if (defined(__TURBOC__))
short int dummy;	/* 窠 ⨢  ࡮- 2.0		    */
#endif

int	i, j, Pack=0, Create=0, Toss=0;
char	*s0;

/* ======================= Command Line help ============================== */
if (argc <= 1)
	{
	puts ("SqWALL V03.07. 'All-in-One' for idiots\n");
	puts ("Usage:");
	puts ("sqwall [commands] [switches]\n");
	puts ("Commands\n");
	puts ("T[OSS] or I[N] O[UT]\tUnpack arcmails, toss .PKT and write .OUT to outbound");
	puts ("S[QWASH] or P[ACK]\tPack .OUT to arcmails and outbound");
	puts ("A[UTOCREATE]\t\tAutoCreate new areas");
	puts ("\nSwitches:\n");
	puts ("-csqwish.cfg\tPathname to config");
	puts ("-ntossing.log\tPathname to Logfile");
	puts ("-iinbound\\\tPath to inbound arcmails");
	exit(200);
	}
else;
/* ========================================================================= */
for (i = 1; i < argc; i++)
     {
     s0 = argv[i];
     switch (toupper(*s0++))
	{
	case '-':
	switch(toupper(*s0++))
	   {
	   case 'N': if (*s0 != '\0') strcpy(ntossing_log, s0-2); else; break;
	   case 'C': if (*s0 != '\0') strcpy(csqwish_cfg, s0-2); else; break;
	   case 'I': if (*s0 != '\0') strcpy(iinbound, s0-2); else; break;
	   default:  fputs (s0-2, stdout); puts (" - Wrong switch ignored"); break;
	   } /* if switch after - */
	break;
	case 'P':
	case 'S': Pack = 1; break;
	case 'I':
	case 'T':
	case 'O': Toss = 1; break;
	case 'A': Create = 1; break;
	default: fputs(s0-1, stdout); puts (" - Wrong command ignored"); break;
	} /* switch */
     } /* for i = 1; i < argc */
/* ================== Sequentially running ================================ */
i = 0;
Line = 1;
while(Lines[i])
	{
	args = &(Lines[i]);
	if (!stricmp(Lines[i], "sqafix"))
	   if (Create) goto Run; else goto NoRun;
	else;
	if (!stricmp(Lines[i], "sqwacr"))
	   if (Create) goto Run; else goto NoRun;
	else;
	if (!stricmp(Lines[i], "sqwish"))
	   if (Toss) goto Run; else goto NoRun;
	else;
	if (!stricmp(Lines[i], "sqwarcx"))
	   if (Toss) goto Run; else goto NoRun;
	else;
	if (!stricmp(Lines[i], "sqwarc"))
	   if (Pack) goto Run; else goto NoRun;
	else;
Run:
	j = System(); if (j) exit(j);
NoRun:
	while(Lines[i]) i++;
	i++;
	Line++;
	}
exit(0);
} /* main() */
/* EOF sqwall.c */
