/* sqwarc.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * (C) 1998 Sergej Qkowlew     2:5020/122@fidonet		 ࣥ 
 *
 *				 V03.06
 *
 * V03.06 skips 'call' as the first     ய᪠    
 * element of sqwash.bat's line.       ப 'call' 䠩 sqwash.bat.
 *
 * Attention!  Command	line params   ! ࠬ   ப  
 * for @sqwash.bat running  CHANGED   ० @sqwash.bat c    諮
 * from previous version 01.03!       ᨨ 01.03!
 *
 * ================================   =========================================
 * Tool for  packing oubound  files   ணࠬ 㯠  室 બ  
 * with using rules in	squish-like   ਬ ࠢ  ᪢订	䠩 
 * file compress.cfg.		      ᠭﬨ 娢஢ - compress.cfg.
 *
 * Version 01.04: =================   =========================================
 *
 * First parameter begins with '@':    ࠬ ᪠ 稭  '@':
 *
 * @sqwash.bat
 *
 * File sqwash.bat is analysed seq-    sqwash.bat ⠥ ᫥⥫쭮,
 * uentially, each line  is interp-     ப   -
 * reted as command line of  sqwarc    ப sqwarc   ,  
 * in elder versions  (but  without    ࠭祭  	 -
 * limitation to MaxCommandLength!)   , ஥ ⠪ 蠫  !
 *
 * Optional parameters: 	      ⥫ ࠬ:
 *
 * -p[c:\arc\] Paranoia on.	      ࠭ ( ᪠ .exe  )
 * -ccompress.cfg  alternate config   䨣 娢஢
 * -ntossing.log	    logfile    (᫨ ᪮  - )
 * -mc:\dos\move.exe   path to move      譥  move
 * -ee	      alternate errors file   ୠ⨢   䠩 e.
 * -ss	     alternate waiting file   ୠ⨢   䠩 s.
 * -r	Delete sqwash.bat;	       sqwash.bat  襭 ࠡ;
 *	rename s to sqwash.bat.       २ s  sqwash.bat.
 *
 * Note, that there is backward co-   ,   ᮢ⨬
 * mpatibility: if first param	has    묨 ﬨ: ᫨    -
 * no leading '@' - sqwarc analyses    ᪠  ᮤন  ᨬ  '@' -
 * command line as sqwarc.bat, cal-   sqwarc   ப ⠪,
 * ling from sqwash.bat executing.       sqwarc.bat, 饭 
 *				      sqwash.bat.
 *
 * Version 01.02 is small corrected    01.02 ᫥ ⪮४஢ 
 * to diminish memory  held  before   㬥襭 ࠧ ⮩   ।
 * calling archiver. No logfile  in   ᪮ 娢.   ᨨ   -
 * DOS version possible. :-(	        뢮  -䠩. ;-(
 *
 * Version 01.00+:
 *
 * If zero-length  arcmail detected   ᫨  ଠ쭮 બ -
 * instead of normal file - program     - ணࠬ  "६-
 * 'increments' file  extention  to   " ७ 䠩,     
 * find non-existant. If all possi-   ᢮. ᫨   ७
 * ble extentions are busy  -  take    䠩 -  ᫥ -
 * last found;	if arcmail is trun-   ; ᫨ બ  ⨬ ७ -
 * cated - delete it.		       -  .
 *
 * Now we read .DLO file  to  check     ஢塞  稥  뫪  
 * existance of reference  to  arc-   બ  䠩 .DLO,  塞 뫪
 * mail, and reference is added on-   ⮫쪮 ᫨  ⢨⥫쭮  室-
 * ly if really needed. 	      .
 * ================================   ========================================
 * Replaces DOS batch file >>>> sqwarc.bat <<<<<<<    䠩,
 * with more effective logic,  more       ४	 ࠡ,
 * correct work  when TruncSent op-   ᮡ  樨 TruncSent.   ⠢-
 * tion is set. But less Conventio-    ᪠ 娢ࠬ   -
 * nal	memory left for running ar-        (  㠫쭮
 * chivers under DOS (actual for HA    HA  RAR'a, ਬ).
 * and RAR, for example).
 *
 * Checks/Creates .bsy flags.	      ஢/ᮧ ४⭮ .bsy 䫠.
 *
 * For existant arcmails checks ar-    㦥 騥 બ  뢠
 * chiver's type and  run  archiver   娢஬    ᮮ⢥⢨  ᮤন
 * according to it's real type, not   બ,    㪠  ⮬  -
 * by described by argv[5].	       sqwash.bat.
 *
 * Errorlevels (global):	      ૥:
 * 105 - can't delete old sqwash.bat.   ᬮ  sqwash.bat
 * 104 - can't rename s to sqwash.bat   ᬮ २ s  sqwash.bat
 * 103 - execvp error (impossible?).   訡 ᯮ execvp.
 * 102 - sqwash.bat not found/wrong.       sqwash.bat
 * 101 - compress.cfg not found/wrong.     compress.cfg
 * 100 - not enough memory to work.     墠⨫   ࠡ.
 *   0 - success summary process       ᯥ譮 襭 㬬୮ .
 *
 * Bink-Style Only		      쪮 -⠩ .
 *
 * Distribution:		      ᮡ ࠭:
 * Source code under GNU license.      室 ⥪,  ࠬ GNU.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include <fcntl.h>

#include "./sqw-os.h"   /* OS-aware definitions */
#include "./sqw-cfg.h"  /* RENAME_ params get from here */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#define MAXARGS 20	/* ᨬ쭮 ⢮ 㬥⮢ args[]	    */
#define MAXARGH 7	/* ᨬ쭮 ⢮ 㬥⮢ argh[]	    */
#define ARCMAX 40	/* ᨬ쭮 㥬 ᫮ 娢஢	    */
#define MAXLINE 4096	/* ᨬ쭠  ப ⠥  䠩	    */
#define LENEXT 3	/*  ७ 䠩 (᫥ ᫥ 窨)   */
#define TOSSING_LOG 1	/* ᫨ 0 -  UNIX ⮫쪮 syslog, DOS - stdout    */
/* =========== ⨯   㭪権 =========================== */
int	Read_Compress_Cfg(char *, char *, char *);
char  **From_Compress_Cfg(char *, char *, char *);
int	System(char **);
void	Write_Line_Back(int, char **, char *);
void	Write_Line_Dlo(void);
int	Move(char *, char *);
void	Remove_arc(int, char **);
void	strcpy2(char *, char *, char, char *);
/* ============ 饭  訡    =========================== */
char	*sqwarc;			/* name of running programm	    */
char	*arcpath = NULL;

static char
	IO_Error[] = "File not found or I/O Error: ",
	Cant_move[] = "Can't move file ",
	Cant_delete[] = "Can't delete file" ,
	to[] = " to ",
	Cant_append[] = "Can't append line ",
	empty[] = "",
	your_os[] = YOUR_OS;

#if (defined(UNIX))

#include <sys/types.h>
#include <sys/wait.h>

#if TOSSING_LOG
static char *tossing_log = NULL;
#endif
static char *movecommand = "mv";
static char Format_ssss[] = "%s%s%s%s";
#define OutLog4(A,B,C,D) syslog(LOG_INFO,Format_ssss,A,B,C,D)

#else /* UNIX */

static char *movecommand = "move /Y";

#include <process.h>

#if TOSSING_LOG

static char *tossing_log = NULL;
static FILE *filelog = NULL;
#define openlog(A,B,C)	if (tossing_log) filelog = fopen(tossing_log,at); else
#define closelog() if (filelog) fclose(filelog); else

/* =========== 뢮    ப  ᡮ   ப =========== */
void OutLog4(char *s1, char *s2, char *s3, char *s4)
{
if (filelog == NULL) filelog = stdout; else;
fputs(sqwarc, filelog);
fputs(": ",filelog);
fputs(s1,filelog);
fputs(s2,filelog);
fputs(s3,filelog);
fputs(s4,filelog);
fputc('\n', filelog);
} /* OutLog4() */

#else /* TOSSING_LOG */

#define openlog(A,B,C)

void OutLog4(char *s1, char *s2, char *s3, char *s4)
{
fputs(sqwarc, stdout);
fputs(": ",stdout);
fputs(s1,stdout);
fputs(s2,stdout);
fputs(s3,stdout);
puts(s4);
} /* OutLog4() */
#define closelog()

#endif /* else TOSSING_LOG */
#endif /* else UNIX */

#include "./_bsyflag.c"  /* .bsy files creation and deleting subroutines */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
static	int	LowerCase = 1;
static	int	paranoia = 0;		/* if 1 - not search exec in PATH   */
static	char *dlo[] = {".DLO", ".dlo"}; /* Extention for .?LO files         */
static	char *out[] = {".OUT", ".out"}; /* Extention for .OUT files         */
static	char *pkt[] = {".PKT", ".pkt"}; /* Extention for .PKT files         */
static	char *xqw[] = {"XQW", "xqw"};
static	char *bsy[] = {"BSY", "bsy"};
static	char *Ss[]  = {"S", "s"};       /* s. filename                      */
static	char *Ee[]  = {"E", "e"};       /* e. filename                      */
static	char *Aa[]  = {"A", "a"};       /* to increment last char of ext    */
static	char *Zz[]  = {"Z", "z"};       /* to increment last char of ext    */

static	char	pathname_dlo[MAXPATH+1];
static	char	pathname_out[MAXPATH+1];
static	char	pathname_pkt[MAXPATH+1];

char	*pathname_arc;			/* arcmail path+name+ext	    */
char	*arctype = "ZIP";               /* Default packer if no %5 param    */

static char	*compress_cfg = "compress.cfg",         /*  䨣      */
		rb[] = "rb", at[] = "at", rt[]="rt";    /* ਡ fopen   */
static char	before_path;		/* # or ^ in .dlo file		    */
static struct stat f;			/*   㭪樨 stat	    */
static char	*argh[MAXARGH]; 	/* ஠஢ ப  .bat */

static		int  arcmail_not_here;	/* 稥 બ argv[3]	    */

/* ============================================================================
 * Invoke system command and return   맢 ⥬      
 * with errorlevel to be analysed.    祭  襭  .
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
int	System(char **args)
{
int k = 0, Summary = 0;

/* ------ Check summary length and path lengths in args -------------------- *
 * And do NOT tell me about 'no li-    ⮫쪮       ⢨
 * mits' in your OS!                  ࠭祭  襩 !
 * ------------------------------------------------------------------------- */
for (k = 0; k < MAXARGS; k++)
    {
    if (args[k])
      {
      Summary += strlen(args[k]); /* ###61 moved here! */
      if(strlen(args[k]) > MAXPATH)
	{ OutLog4("Too long path ", args[k], empty, empty);
	return 255;
	}
      else;
      if (Summary > MAXCMDLEN)
	{ OutLog4("Too long command line built for archiver running",
		empty, empty,empty);
	return 255;
	}
      else;
      } /* if (args[k]) */
    else break;
    } /* for k < MAXARGS */

#if DEBUG
/**/k = 0;
/**/while(args[k]) printf(" %s", args[k++]); puts(empty);
/**/fputs("System(); Press Enter to continue sqwarc executing>", stderr); getchar();
#endif

#if (defined(UNIX))
if (fork()) {wait(&k); k = WEXITSTATUS(k);}
else	{
	if (paranoia) execv(args[0], args);
	else execvp(args[0], args);
	exit(103);
	}
#elif (defined(__VC60__))
if (paranoia)	k = _spawnv(_P_WAIT, args[0], args);
else		k = _spawnvp(_P_WAIT, args[0], args);
#if DEBUG
perror("After spawnv: ");
#endif
#else /* UNIX, __VC60__ */
if (paranoia)	k = spawnv(P_WAIT, args[0], args);
else		k = spawnvp(P_WAIT, args[0], args);
#endif /* else UNIX */
return k;
}

/* ============================================================================
 * Appends line of argv[]  to  file   뢠 ப   㬥⮢	argv  
 * named "s" or "e"  for later use,   䠩, 㥬 "e"  "s"   ⫮-
 * if packing can not  be completed     ⮬ ᯮ짮, ᫨ 㯠-
 * for some reason (.bsy flag  cau-         襭.  .bsy  䫠
 * ses file "s", packing errors - e   -  䠩 s, 訡 -  䠩 e.
 * ------------------------------------------------------------------------- */
void	Write_Line_Back(int argc, char **argv, char *s)
{
register int i;
FILE *filebat = fopen (s,at);

if (filebat == NULL) OutLog4(Cant_append, to, s, empty);
else
    {
    for (i = 0; i < argc; i++)
	{
	fputs(argv[i], filebat);
	fputc(' ',filebat);
	}
   fputc ('\n',filebat);
   fclose (filebat);
   }
} /* Write_Line_Back */

/* ========================================================================= *
 * Reads .dlo file if exist. If  it   ⠥ 䠩  .dlo, ᫨    .
 * contains reference to our arcma-   ᫨     뫪  બ -  
 * il - returns. If do	not contain   祣  .  ᫨ 뫪  - 
 * reference - append line to it.      ᮮ⢥   .dlo
 *
 * Fully rewritten from 'fopen'  to    ९ᠭ  ⨫ 'fopen'  
 * 'open' style because  of  Bink/+   ⨫ 'open', ⠪  Bink/+ ⠥ .?LO
 * reading .?LO files  in  DENYNONE   䠩  ᫨   ...
 * mode even if BSY is setted.
 * ------------------------------------------------------------------------ */
void	Write_Line_Dlo()
{
int reference = 1;
unsigned	char tmp[MAXPATH+4];	/* ஬筠 ப 	    */
int	handle,
	readen,
	result;
char	*s0;
handle = open(pathname_dlo,O_RDONLY | O_DENYNONE);
if (handle != -1)
   {
   do	{
	readen = 0;
	s0 = tmp;
	while ((result = read(handle,s0,1)) == 1)
	      {
	      if ((*s0 == '\r') || (*s0 == '\n') || (*s0 == '\0')) break;
	      else;
	      s0++;
	      readen++;
	      }
	*s0 = '\0';
	if (readen)
	      {
#if (defined(__TURBOC__))
	      if (!stricmp(tmp + 1, pathname_arc))
#else
	      if (!strcmp(tmp + 1, pathname_arc))
#endif
		   reference = 0;
	      else;
	      }
	else;
	}
   while (reference && (result == 1));
   close(handle);
   }
else;

if (!reference) return; else;	 /* ᫨ 뫪 㦥  -    */

if (handle != -1)
     handle = open(pathname_dlo, O_WRONLY | O_APPEND | O_TEXT | O_DENYWRITE);
else handle = open(pathname_dlo, O_WRONLY | O_CREAT  | O_TEXT | O_DENYWRITE);

if (handle != -1)
   {
   s0 = tmp;
   *s0++ = before_path;
   strcpy(s0,pathname_arc);
   s0 += strlen(s0);
   *s0++ = '\n';
   *s0 = '\0';
   result = write(handle,tmp,(unsigned int)(s0 - tmp));
   if (result == -1) goto Err_Append; else;
   close(handle);
#ifdef UNIX
   chmod(pathname_dlo,SQW_RWFILE);	/*   直 砩... */
#endif
   }
else
   {
Err_Append:
   if (handle != -1) close(handle); else;
#if DEBUG
/**/fputs(Cant_append, stdout); fputs(pathname_arc, stdout);
/**/fputs(to, stdout); fputs(pathname_dlo, stdout);
/**/fputs(">", stdout); getchar();
#endif
   OutLog4(Cant_append, pathname_arc, to, pathname_dlo);
   }
} /* Write_Line_Dlo */

/* ------------------------------------------------------------------------ *
 * Deletes arcmail.		      ࠥ 䠩 બ.
 * ------------------------------------------------------------------------ */
void Remove_arc (int argc, char *argv[])
{
if (remove(argv[3]))		/*   	     */
   {				/* 㤠筠 ⪠  */
   Write_Line_Back (argc, argv, Ee[LowerCase]);
   bsy_remove();
   return;
   }
else;
} /* void Remove_arc */

/* ============================================================================
 * Returns 0 if success
 * Or result of System or unlink.
 * ------------------------------------------------------------------------- */

int Move (char *otkuda, char *kuda)
{
char *args[MAXARGS];
#if (defined(UNIX))

link(otkuda, kuda);
switch(errno)
	{
	case 0:
		if (unlink(otkuda)) return 1; else return 0;
	case EXDEV:    case EPERM:    case EMLINK:
/*
 * If link is impossible  for  some   ᫨  ᤥ  link    
 * reasons  -  shell command  mv is   稭 - 뢠  襫 mv.
 * invoked.
 */
		args[0] = movecommand;
		args[1] = otkuda,
		args[2] = kuda;
		args[3] = NULL;
		return (System(args));
	default:
		return 1;
	} /* switch errno */

#else	/*   ᮬ 襢 ࠧ  move */
		{ int i; char movecopy[MAXPATH+1], *s;
		strcpy(movecopy, movecommand);
		i = 0;
		args[i] = strtok(movecopy, " ");
		do args[++i] = strtok(NULL, " ");
		while ((i < MAXARGS) && (args[i]));
		args[i++] = otkuda,
		args[i++] = kuda;
		args[i] = NULL;
#if DEBUG
/**/while(i > 0) puts(args[--i]);
#endif
		return (System(args));
		}
#endif
} /* int Move() */

#include "./_compres.c"

/* ====================  ப  ᮡ⢥ ࠡ ================= */
void Line_Analysis(int argc, char **argv)
{
char	 **args;	 /*   spawnvp/execvp	      */
char *lastchar, *s0;
int k;

#if DEBUG
/**/puts(""); for (k = 0; k < argc; k++) printf("%s ", argv[k]); puts("");
#endif
pathname_arc = argv[3]; lastchar = pathname_arc + strlen(pathname_arc) - 1;
before_path = *argv[4];
LowerCase = 0;
if (before_path == 'd') {LowerCase = 1; before_path = '#';} else;
if (before_path == 'g') {LowerCase = 1; before_path = '^';} else;

if (argc != 5) arctype = argv[5]; else;

/* ------------------ Move file to LocalPath ------------------------------ */
if ((argc == 6) && (!stricmp(argv[5], "LOC")))
    {
    strcpy2(pathname_out, argv[1],'.',argv[3]);
    Move(pathname_out, argv[2]);
#if DEBUG
/**/puts("LOC archiver - moving file");
#endif
    return;
    } /* if LOC */
else;

/* ------------------ Check - what .o?? file exists here? ----------------- */
strcpy2(pathname_out,argv[1],'\0', out[LowerCase]);
if (stat(pathname_out,&f))		/* not found .out file: 	    */
   {
   s0 = argv[3] + strlen(argv[3]) - LENEXT - 1;/* s0 - 㪠뢠 ७ */
						/* 室 䠩	     */
   if (toupper(s0[1]) != 'O') goto Not_Found_to_be_sent; else;
   strcpy2(pathname_out, argv[1], '\0', s0);
   if (stat(pathname_out,&f))
	{
Not_Found_to_be_sent:
	OutLog4(pathname_out, " - Not found file to be sent",empty,empty);
	Write_Line_Back (argc, argv, Ee[LowerCase]);
	return;
	}
   else {	/*  뫠 䠩,    .out -     */
	arctype = NULL;
	} /* else stat("name.ops,...") */
   } /* if stat("name.out") */
else;

strcpy2(pathname_dlo, argv[2], '\0', dlo[LowerCase]);
strcpy2(pathname_pkt, argv[1], '\0', pkt[LowerCase]);

if ((before_path != '#') && (before_path != '^')) return; else;

strcpy2(pathname_bsy, argv[2], '.', bsy[LowerCase]);
strcpy2(pathname_tmp, argv[2], '.', xqw[LowerCase]);
#if DEBUG
/**/puts(pathname_bsy);puts(pathname_tmp);
#endif
if (bsy_create() == -1) 			/*    */
    Write_Line_Back (argc, argv, Ss[LowerCase]);
else{
    if (arctype)
	{				/*  ᮧ ᢮    */
/* V01.00+ (Was trivial removing zero-length arcmail) */
	do {
	   arcmail_not_here = stat(pathname_arc,&f);
	   if (!(arcmail_not_here)) /*  બ */
	      if (f.st_size == 0L)			/*  㫥  */
		{
		if ((before_path == '#') &&     /* ᫨  ᥪ */
		    ((*lastchar) < *(Zz[LowerCase])))/*    	*/
		    if ((*lastchar) == '9')
			 *lastchar = *Aa[LowerCase];
		    else (*lastchar)++;
		else {				/*    */
		     Remove_arc(argc, argv);
		     arcmail_not_here = 1;
		     }
		} /* if (f.st_size == 0L) */
	      else break;			/* 㫥 બ */
	   else break;				/*  બ */
	   }
	while (!arcmail_not_here);
/* V01.00- */
	if (((args = From_Compress_Cfg(pathname_arc, arctype, pathname_pkt))
		 == NULL) ||			   /*  諨 娢 */
	    (rename (pathname_out, pathname_pkt))) /*   २ */
		{
		Write_Line_Back (argc, argv, Ee[LowerCase]);
		bsy_remove();
		return;
		}
	else;
/* ᫨  -   args 㦥    spawnvp/execvp */
	k = System(args);
#if DEBUG
/**/	printf ("\nReturned code %i\n", k);
/**/	printf ("Press any key to continue>"); getchar();
#endif
	if (k == 0)			/* ᯥ譠 㯠 PKT  બ  */
		{
		Write_Line_Dlo();
		remove(pathname_pkt);
		}
	else	{
		rename(pathname_pkt,pathname_out);
		OutLog4("Error packing ", pathname_pkt, to, pathname_arc);
		Write_Line_Back (argc, argv, Ss[LowerCase]);
		}
	} /* if arctype */
    else{
	if ((k = Move(pathname_out, argv[3])) == 0)
	   Write_Line_Dlo();
	else {
	     OutLog4(Cant_move,pathname_out, to, argv[3]);
	     Write_Line_Back (argc, argv, Ee[LowerCase]);
	     }
	} /* else arctype */
    bsy_remove();
    }/* else bsy_create */
return;
} /* Line_Analysis() */

/* ===========  ணࠬ ========================================= */
void main (int argc, char **argv)
{
#if (defined(__TURBOC__))
short int dummy;	/* 窠 ⨢  ࡮- 2.0		    */
#endif

char *sqwash_bat = NULL;    /* Pathname to sqwash.bat file		    */
static char tmp[MAXLINE+2]; /* Here is tokenized line from sqwas.bat placed */
char *s0;

FILE	*fileind;	    /* File sqwash.bat opened as text stream	    */
int	i, Wrong_Line = 0, RenameBat = 0;

/* ======================= Command Line help ============================== */
if (argc <= 1)
	{
	puts ("SqWarc V03.06. Addition tool for SqWish V03.06\n");
	puts ("Usage:");
	puts ("sqwarc @sqwash.bat [switches]\n");
	puts ("Switches (possible space between switch and parameter):\n");
	puts ("-ccompress.cfg\t\tPathname to archivers' config");
#if TOSSING_LOG
	puts ("-ntossing.log\t\tLogfile (stdout if no switch)");
#endif
#if (defined(UNIX))
	puts ("-mmv\t\t\tShell alternate 'rename move' command");
	puts ("-p/usr/bin/\t\tParanoic Not search executables in PATH)");
#else
	puts ("-mc:\\dos\\move.exe\tDOS command for move files");
	puts ("-pc:\\arc\\\t\tParanoic Not search executables in PATH)");
#endif
	puts ("-ss\t\t\tAlternate 'left for future lines' file");
	puts ("-ee\t\t\tAlternate 'error packing lines' file");
	puts ("-r\t\t\tDelete sqwash.bat, rename s to sqwash.bat on exit\n");
	puts ("Syntax of lines in sqwash.bat see in distributive, sqwarc.bat.\n");
#if (defined(__TURBOC__))
	fputs (ltoa(farcoreleft(),tmp,10), stdout);
	puts (" bytes available memory");
#endif
	exit(101);
	}
else;
/* ========================================================================= */

if (*argv[1] == '@')
   {
   sqwash_bat = argv[1] + 1;
   for (i = 2; i < argc; i++)
     {
     s0 = argv[i];
     if (*s0++ == '-')
	switch(toupper(*s0++))
	   {
#define Pkey(A,B) case A: if (*s0 == '\0') if (++i == argc) break; \
	else s0 = argv[i]; else; B = s0;

	   Pkey('P', arcpath); paranoia = 1; break;
	   Pkey('M', movecommand); break;
	   Pkey('C', compress_cfg); break;
	   Pkey('E', Ee[0] = Ee[1]); break;
	   Pkey('S', Ss[0] = Ss[1]); break;
#if TOSSING_LOG
	   Pkey('N', tossing_log); break;
#endif
#undef Pkey
	   case 'R': RenameBat = 1; break;
	   default:  fputs (s0-2, stdout); puts (" - Wrong switch ignored"); break;
	   } /* if switch */
     else;
     } /* for i = 2; i < argc */
   sqwarc = argv[0];
   openlog(sqwarc, LOG_PID | LOG_CONS, LOG_USER);
   if (!Read_Compress_Cfg("Add", arcpath, compress_cfg))
      {
      OutLog4(IO_Error, compress_cfg, empty, empty);
      exit(101);
      }
   else;
   fileind = fopen(sqwash_bat, rt);
   if (fileind)
	{
#if DEBUG
/**/printf("Before while(fgets)\n");
/**/printf("Press Enter to continue>"); getchar();
#endif
	while (fgets(tmp,MAXLINE,fileind))
		{
		ClearEOL(tmp);
		argh[0] = strtok(tmp,tabspace); i = 0;
		if (!stricmp(argh[0],"call")) argh[0] = strtok(NULL,tabspace);
		else;
		while  (((argh[++i] = strtok(NULL,tabspace)) != NULL) &&
			(i < MAXARGH));
		if (i < MAXARGH) Line_Analysis(i,argh);
		else Wrong_Line = 1;
#if DEBUG
/**/printf("After Line_Analysis; Wrong_Line = %i\n", Wrong_Line);
/**/printf("Press Enter to continue>"); getchar();
#endif
		}
#if DEBUG
/**/printf("Before  if (ferror(fileind))\n");
/**/printf("Press Enter to continue>"); getchar();
#endif
	if (ferror(fileind)) goto Main_Error;
	else {
	     fclose(fileind);
	     if (Wrong_Line)
		{
		OutLog4("Wrong line in ", sqwash_bat,empty,empty);
		closelog();
		exit(102);
		}
	     else;
	     } /* else ferror(fileind) */
#if DEBUG
/**/printf("Before if (RenameBat); RenameBat = %i\n", RenameBat);
#endif
	if (RenameBat)
	   {
	   if (unlink(sqwash_bat))
	      {
	      OutLog4(Cant_delete, sqwash_bat, empty, empty);
	      exit(105);
	      }
	   else;
	   if (!stat(Ss[LowerCase],&f))
	      {
#if DEBUG
/**/	printf("Before Move(\"%s\", \"%s\");\n", Ss[LowerCase], sqwash_bat);
/**/	printf("Press Enter to continue>"); getchar();
#endif
	      i = Move(Ss[LowerCase],sqwash_bat);
	      if (i || (stat(sqwash_bat,&f)) || (!stat(Ss[LowerCase],&f)))
		 {
		 OutLog4(Cant_move, Ss[LowerCase], to, sqwash_bat);
		 exit(104);
		 }
	      else;
	      } /* if (!stat(s)) */
	   else;
	   } /* if RenameBat */
	else;
	} /* if (fileind) */
   else {
Main_Error:
	OutLog4(IO_Error, sqwash_bat, empty, empty);
	closelog();
	exit(102);
	}
   } /* if *argv[1] == '@' */
else
   {
   openlog(sqwarc, LOG_PID | LOG_CONS, LOG_USER);
   if (!Read_Compress_Cfg("Add", arcpath, compress_cfg))
      {
      OutLog4(IO_Error, compress_cfg, empty, empty);
      exit(101);
      }
   else;
   Line_Analysis(argc,argv);
   }
closelog();
exit(0);
} /* main() */

/* EOF sqwarc.c */
